{$N+,E+}
{$m 65520,0,655360} {moznost pouzit maximum pameti}
{****************************************************************************
 *         } Program MISOCalc;{ (C) 1999 Michal Cihar                       *
 ****************************************************************************}
uses Ucalcul,      {vlastni zpracovani vyrazu}
     udata,       {datove struktury pro calcul}
     umemory,      {pamet a konstanty}
     strfunc,     {prevody cisel na retezce a prace s retezci}
     ukbd,uscreen,{moje unity misto CRT - problemy s casovacem na
                   rychlejsich pocitacich}
     uhistory,    {historie prikazu}
     dos,         {cteni casu}
     uparams,     {cteni casu}
     uClip;       {clipboard}

type tPrintout= record
                hex,
                dec,
                oct,
                bin,
                udf,
                allowed:boolean;
                base:byte;
              end;

const
      {Program information:}
      ProgramName        ='MISO Calc';
      ProgramVersion     ='1.54';
      ProgramRelease     ='28.2.1999';
      ProgramCopyright   ='(C) 1999 Michal Cihar';
      ProgramFileCreator ='MISOCalc';

      InitScript         ='MISOCALC.PRG';

      AuthorMail         ='cihar@iname.com';
      AuthorSite         ='http://miso.fd.cz';

      TitleStart         ='۲';
      TitleEnd           ='';

      {Commands:}
      CmdExit            :string[15]='EXIT';
      CmdQuit            :string[15]='QUIT';
      CmdLocalQuit       :string[15]='KONEC'; {<- should be loadable}

      CmdSave            :string[15]='@SAVE';
      CmdSaveOld         :string[15]='@EXPORT';
      CmdLoad            :string[15]='@LOAD';
      CmdLoadDBF         :string[15]='@LOADDBF';
      CmdLoadOld         :string[15]='@IMPORT';
      CmdDelete          :string[15]='@DELETE';
      CmdEmpty           :string[15]='@EMPTY';
      CmdCls             :string[15]='@CLS';
      CmdMem             :string[15]='@MEM';
      CmdASCII           :string[15]='@ASCII';
      CmdBase            :string[15]='@BASE';
      CmdWinClip         :string[15]='@WINCLIP';
      CmdEmuClip         :string[15]='@EMUCLIP';
      CmdClip            :string[15]='@CLIP';
      CmdExec            :string[15]='@EXEC';
      CmdStartInfo       :string[15]='@STARTINFO';
      CmdLogoOff         :string[15]='@LOGOOFF';
      CmdLogoOn          :string[15]='@LOGOON';

      CmdList            :string[15]='@LIST';
      CmdListC           :string[15]='@LISTC';

      CmdHex             :string[15]='@HEX';
      CmdDec             :string[15]='@DEC';
      CmdOct             :string[15]='@OCT';
      CmdBin             :string[15]='@BIN';
      CmdUdf             :string[15]='@UDF';
      CmdDeg             :string[15]='@DEG';
      CmdRad             :string[15]='@RAD';
      CmdGrad            :string[15]='@GRAD';
      CmdAns             :string[15]='@ANS';

      CmdSetDerDelta     :string[15]='@SETDERDELTA';
      CmdSetSolDelta     :string[15]='@SETSOLDELTA';
      CmdSetSolCycle     :string[15]='@SETSOLCYCLE';

      CmdSetIntDivision  :string[15]='@SETINTDIV';

      CmdAllowResult     :string[15]='@ALLOWRESULT';
      CmdForbidResult    :string[15]='@FORBIDRESULT';

      CmdMaxHistory      :string[15]='@MAXHISTORY';

      {commands for scripts:}
      CmdDisplay         :string[15]='&DISPLAY';
      CmdNoDisplay       :string[15]='&NODISPLAY';
      CmdAllDisplay      :string[15]='&ALLDISPLAY';
      CmdPause           :string[15]='&PAUSE';
      CmdWait            :string[15]='&WAIT';
      CmdGet             :string[15]='&GET';
      CmdWrite           :string[15]='&WRITE';
      CmdAttrib          :string[15]='&ATTRIB';
      CmdGoto            :string[15]='&GOTO';
      CmdLabel           :string[15]='&LABEL';
      CmdEnd             :string[15]='&END';
      CmdIf              :string[15]='&IF';
      CmdThen            :string[15]='THEN';
      CmdElse            :string[15]='ELSE';

      {Messages:                           <- all should be loadable}
      MsgError           :string[15]='Chyba';
      MsgWaitForKey      :string[80]='Stisknete klavesu pro pokracovani...';
      MsgCalculating     :string[20]='Pocitam... ';
      MsgCalculate       :string[14]='Pocitam vyraz:';

      MsgConstantList    :string[20]='Vypis konstant';
      MsgConstantDesc    :string[60]='jmeno=hodnota (informace [jednotky])';

      MsgVariableList    :string[20]='Vypis promennych';
      MsgVariableDesc    :string[40]='jmeno=hodnota';
      MsgNoVariable      :string[40]='Zadne promenne nebyly definovany';

      MsgStartInfo       :string[80]='Program ukoncite napsanim KONEC/EXIT/QUIT. Napoveda - ?';

      MsgBadNumber       :string[40]='spatne zadane cislo';

      LogoLicence        :array[1..6] of string[28]=
                         ('Tento program muze byt volne',
                          'siren  jako   FREEWARE,  ale',
                          'NIKDO  neodpovida  za  zadne',
                          'skody  zpusobene  pouzivanim',
                          'tohoto programu.            ',
                          '                            ');
      LogoContact        :string[50]='Pripominky a dotazy zasilejte na e-mail:';
      LogoSite           :string[50]='Posledni verze a dalsi programy by mely byt na:';
      MsgVersion         :string[15]='verze';
      MsgRelease         :string[15]='ze dne';
      MsgUses            :string[15]='Pouziva';
      MsgPrompt          :string[14]='Zadejte vyraz:';
      MsgThanx           :string[40]='Dekuji za pouziti programu';
      MsgResult          :string[15]='Vysledek:';
      MsgNoExpression    :string[80]='Nebyl zadan zadny vyraz!';

      DefaultExtension   :string[4]='.PRG'; {including comma '.'}

      PromptInputEOF     :string[3]=#0#255#255;
      PromptInputFirst   :string[2]=#0#255;
      PromptInputDone    :string[2]=#0#254;


      {Printout CELYCH cisel}
      Printout:tPrintout=(hex     :false;
                          dec     :false;
                          oct     :false;
                          bin     :false;
                          udf     :false;
                          allowed :true;
                          base    :36);
      ScriptActive                :boolean=false;
      DisplayLogoOnQuit           :boolean=true;
      AnsState                    :boolean=true;
      WasQuit                     :boolean=false;

      MaximalBaseOut              :tRealNumber=1048576.0*1048576.0*1048576.0;

      {Colors:}
      ColorInfo                   :byte=3;         {barva uvodni informace}
      ColorPrompt                 :byte=11;{9}   {barva promptu}
      ColorError                  :byte=4;        {barva chyby}
      ColorText                   :byte=7;
      ColorTextBackground         :byte=0;
      ColorSelectedText           :byte=0;
      ColorSelectedTextBackground :byte=7;
      ColorCmdWrite               :byte=7;


      {toto je stavova radka ktera je nahore na obrazovce uklada se primo do
      pameti}
      status:tline=
{1}   ((character:' ';attr:10+(7 shl 4)),
       (character:'M';attr:10+(7 shl 4)),
       (character:'I';attr:10+(7 shl 4)),
       (character:'S';attr:10+(7 shl 4)),
       (character:'O';attr:10+(7 shl 4)),
       (character:' ';attr:10+(7 shl 4)),
       (character:'C';attr:09+(7 shl 4)),
       (character:'a';attr:09+(7 shl 4)),
       (character:'l';attr:09+(7 shl 4)),
{10}   (character:'c';attr:09+(7 shl 4)),
       (character:' ';attr:10+(7 shl 4)),
       (character:'v';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'1';attr:00+(7 shl 4)),
       (character:'.';attr:00+(7 shl 4)),
       (character:'5';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:'4';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
{20}   (character:' ';attr:00+(7 shl 4)),
       (character:' ';attr:14+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'N';attr:14+(7 shl 4)),
       (character:'O';attr:14+(7 shl 4)),
       (character:'R';attr:14+(7 shl 4)),
       (character:'M';attr:14+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
{30}   (character:' ';attr:00+(7 shl 4)),
       (character:'P';attr:08+(7 shl 4)),
       (character:'R';attr:08+(7 shl 4)),
       (character:'G';attr:08+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'U';attr:08+(7 shl 4)),
       (character:'H';attr:08+(7 shl 4)),
       (character:'D';attr:14+(7 shl 4)),
{40}   (character:'O';attr:08+(7 shl 4)),
       (character:'B';attr:08+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'A';attr:14+(7 shl 4)),
       (character:'N';attr:14+(7 shl 4)),
       (character:'S';attr:14+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
{50}   (character:' ';attr:00+(7 shl 4)),
       (character:'D';attr:14+(7 shl 4)),
       (character:'E';attr:14+(7 shl 4)),
       (character:'G';attr:14+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'N';attr:14+(7 shl 4)),
       (character:'U';attr:14+(7 shl 4)),
       (character:'M';attr:14+(7 shl 4)),
{60}   (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'O';attr:14+(7 shl 4)),
       (character:'V';attr:14+(7 shl 4)),
       (character:'R';attr:14+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'M';attr:08+(7 shl 4)),
{70}   (character:'E';attr:08+(7 shl 4)),
       (character:'M';attr:08+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'';attr:00+(7 shl 4)),
       (character:' ';attr:00+(7 shl 4)),
       (character:'0';attr:00+(7 shl 4)),
       (character:'0';attr:00+(7 shl 4)),
       (character:':';attr:00+(7 shl 4)+128),
       (character:'0';attr:00+(7 shl 4)),
       (character:'0';attr:00+(7 shl 4)),
{80}   (character:' ';attr:00+(7 shl 4)));

var {c:tRealNumber;  {vypocitane cislo}
    b:boolean; {jestli byl vypocet v poradku}
    lasty:byte;{posledni y souradnice}
    Clipboard:PClipboardString;

function ExecuteScript(filename:string):byte;forward;

procedure EndSmall;
begin;
textcolor(ColorInfo);
textbackground(0);
writeln(MsgThanx+' '+ProgramName+' '+MsgVersion+' '+ProgramVersion+' '+ProgramCopyright);
end;


{vypise chybu}
procedure pis_ch(s:string);
begin;
textcolor(ColorError);
textbackground(0);
writeln(s);
textcolor(7);
textbackground(0);
end;

{nastavi okno pro prompt}
procedure setwin;
begin;
window(1,2,columns{80},rows{25});
textcolor(7);
textbackground(0);
gotoxy(1,lasty);
end;

{nastavi okno na celou obrazovku}
procedure fullwin;
begin;
window(1,1,columns{80},rows{25});
gotoxy(1,1);
end;

{logo programu}
procedure proglogo;
procedure logocolor;
begin;
textcolor(9);
textbackground(0);
end;
procedure misocolor;
begin;
textcolor(10);
textbackground(0);
end;
procedure warncolor;
begin;
textcolor(12);        {15.4}
textbackground(0);
end;
procedure ColorInfo;
begin;
textcolor(15);
textbackground(0);
end;
procedure mailcolor;
begin;
textcolor(11);
textbackground(0);
end;
begin;
fullwin;
ColorInfo;
clrscr;
misocolor;
writeln('');
writeln('');
writeln('');
writeln('');
write('ͻ    ͻ  ͻ   ͻ   ͻ  ');
warncolor;
writeln(' Ŀ ');
misocolor;
write(' ͻȻ  ɼͻ      ɼͻȻ   ͻ   ');
warncolor;
writeln('  '+LogoLicence[1]+'  ');
misocolor;
write('  ȻȻɼɼ       Ȼͻͼ          ');
warncolor;
writeln('  '+LogoLicence[2]+'  ');
misocolor;
write('   Ȼȼɼ         ͻ             ');
warncolor;
writeln('  '+LogoLicence[3]+'  ');
misocolor;
write('    ͼ            ͻ           ');
warncolor;
writeln('  '+LogoLicence[4]+'  ');
misocolor;
write('                 ͻͻȻ          ');
warncolor;
writeln('  '+LogoLicence[5]+'  ');
misocolor;
write('                 Ȼͼɼ   ͼ   ');
warncolor;
writeln('  '+LogoLicence[6]+'  ');
misocolor;
write('ͼ          ͼ  ͼ   ͼ   ͼ  ');
warncolor;
writeln('  ');
mailcolor;
writeln('');
writeln(' '+LogoContact+' '+AuthorMail);
writeln('');
writeln(' '+LogoSite+' '+AuthorSite);
writeln('');
logocolor;
write('  C   A  L    C                              ');
ColorInfo;
writeln('                             ');
logocolor;
write(' C C A A L   C C                         ');
ColorInfo;
writeln('                             ');
logocolor;
write(' C   AAA L   C                              ');
ColorInfo;
writeln('  '+MsgVersion+' '+ProgramVersion);
logocolor;
write(' C C A A L   C C                          ');
ColorInfo;
writeln('  '+MsgRelease+' '+ProgramRelease);
logocolor;
write('  C  A A LLL  C                          ');
ColorInfo;
writeln('  '+ProgramCopyright);
{write('ͻ    ͻ  ͻ   ͻ   ͻ  ');
warncolor;
writeln(' Ŀ ');
misocolor;
write(' ͻȻ  ɼͻ      ɼͻȻ   ͻ   ');
warncolor;
writeln('  Tento program muze byt volne  ');
misocolor;
write('  ȻȻɼɼ       Ȼͻͼ          ');
warncolor;
writeln('  siren  jako   FREEWARE,  ale  ');
misocolor;
write('   Ȼȼɼ         ͻ             ');
warncolor;
writeln('  NIKDO  neodpovida  za  zadne  ');
misocolor;
write('    ͼ            ͻ           ');
warncolor;
writeln('  skody  zpusobene  pouzivanim  ');
misocolor;
write('                 ͻͻȻ          ');
warncolor;
writeln('  tohoto programu.              ');
misocolor;
write('                 Ȼͼɼ   ͼ   ');
warncolor;
writeln('                                ');
misocolor;
write('ͼ          ͼ  ͼ   ͼ   ͼ  ');
warncolor;
writeln('  ');
mailcolor;
writeln('');
writeln(' Pripominky a dotazy zasilejte na e-mail: cihar@iname.com nebo');
writeln('                                          nijel@email.com');
writeln(' Posledni verze a dalsi programy by mely byt na: http://miso.fd.cz');
writeln('');
logocolor;
write('  C   A  L    C                              ');
ColorInfo;
writeln('                             ');
logocolor;
write(' C C A A L   C C                         ');
ColorInfo;
writeln('                             ');
logocolor;
write(' C   AAA L   C                              ');
ColorInfo;
writeln('      verze '+ProgramVersion);
logocolor;
write(' C C A A L   C C                          ');
ColorInfo;
writeln('      ze dne '+ProgramRelease);
logocolor;
write('  C  A A LLL  C                          ');
ColorInfo;
writeln('      '+ProgramCopyright);}
end;

procedure writestartinfo;
begin;
textcolor(ColorInfo);
textbackground(0);
writeln(ProgramName+' '+MsgVersion+' '+ProgramVersion);
writeln(MsgUses+' '+UCalcul.UnitID+
        ' (C) '+UCalcul.unitcopyright+' '+
        MsgVersion+' '+UCalcul.UnitVersion+' ('+UCalcul.UnitRelease+')');
writeln(MsgStartInfo);
end;

{zmena  ve stavove radce}
procedure zmenvypis;
begin;
with Printout do
begin;
if udf then status[37].attr:=14+(7 shl 4)
       else status[37].attr:=08+(7 shl 4);
if hex then status[38].attr:=14+(7 shl 4)
       else status[38].attr:=08+(7 shl 4);
if dec then status[39].attr:=14+(7 shl 4)
       else status[39].attr:=08+(7 shl 4);
if oct then status[40].attr:=14+(7 shl 4)
       else status[40].attr:=08+(7 shl 4);
if bin then status[41].attr:=14+(7 shl 4)
       else status[41].attr:=08+(7 shl 4);
end;
end;

{zmena uhlove miry ve stavove radce}
procedure zmenmiru;
begin;
case AngleMeas of deg:begin;
                         status[51].character:='D';
                         status[52].character:='E';
                         status[53].character:='G';
                       end;
                   rad:begin;
                         status[51].character:='R';
                         status[52].character:='A';
                         status[53].character:='D';
                       end;
                  grad:begin;
                         status[51].character:='G';
                         status[52].character:='R';
                         status[53].character:='A';
                       end;
                   end;
end;

{zmena numlocku na stavove radce}
procedure zmennum;
begin;
case num_lock of true:begin;
                         status[57].attr:=14+(7 shl 4);
                         status[58].attr:=14+(7 shl 4);
                         status[59].attr:=14+(7 shl 4);
                       end;
                 false:begin;
                         status[57].attr:=08+(7 shl 4);
                         status[58].attr:=08+(7 shl 4);
                         status[59].attr:=08+(7 shl 4);
                   end;
                   end;
end;

{zmena programu na stavove radce}
procedure zmenprg;
begin;
case ScriptActive of true:begin;
                         status[31].attr:=14+(7 shl 4);
                         status[32].attr:=14+(7 shl 4);
                         status[33].attr:=14+(7 shl 4);
                      end;
                false:begin;
                         status[31].attr:=08+(7 shl 4);
                         status[32].attr:=08+(7 shl 4);
                         status[33].attr:=08+(7 shl 4);
                  end;
                  end;
end;

{zmena ANS na stavove radce}
procedure zmenans;
begin;
case AnsState of true:begin;
                         status[45].attr:=14+(7 shl 4);
                         status[46].attr:=14+(7 shl 4);
                         status[47].attr:=14+(7 shl 4);
                       end;
                 false:begin;
                         status[45].attr:=08+(7 shl 4);
                         status[46].attr:=08+(7 shl 4);
                         status[47].attr:=08+(7 shl 4);
                       end;
                   end;
end;

{zmena insertu na stavove radce}
procedure zmenins;
begin;
case insert_status of true:begin;
                         status[63].character:='O';
                         status[64].character:='V';
                         status[65].character:='R';
                       end;
                 false:begin;
                         status[63].character:='I';
                         status[64].character:='N';
                         status[65].character:='S';
                       end;
                   end;
end;

{zmena pameti na stavove radce}
procedure zmenpamet;
begin;
case IsFreeMemory of 1:begin;
                         status[69].attr:=12+(7 shl 4);
                         status[70].attr:=12+(7 shl 4);
                         status[71].attr:=12+(7 shl 4);
                       end;
                  2:begin;
                         status[69].attr:=12+(15 shl 4);
                         status[70].attr:=12+(15 shl 4);
                         status[71].attr:=12+(15 shl 4);
                       end;
                  0:begin;
                         status[69].attr:=08+(7 shl 4);
                         status[70].attr:=08+(7 shl 4);
                         status[71].attr:=08+(7 shl 4);
                       end;
                   end;
end;

procedure zmencas(Hour, Minute:word);
var str:string;
begin;
str:=Word2String2(hour);
status[75].character:=str[1];
status[76].character:=str[2];
str:=Word2String2(minute);
status[78].character:=str[1];
status[79].character:=str[2];
end;

{pise stavovou radku}
procedure pisstatus;
begin;
putline(1,status);
end;

procedure updatestat;
var str:string;
    Hour, Minute, Second, Sec100: Word;
begin;
with Printout do
begin;
if udf then status[37].attr:=14+(7 shl 4)
       else status[37].attr:=08+(7 shl 4);
if hex then status[38].attr:=14+(7 shl 4)
       else status[38].attr:=08+(7 shl 4);
if dec then status[39].attr:=14+(7 shl 4)
       else status[39].attr:=08+(7 shl 4);
if oct then status[40].attr:=14+(7 shl 4)
       else status[40].attr:=08+(7 shl 4);
if bin then status[41].attr:=14+(7 shl 4)
       else status[41].attr:=08+(7 shl 4);
end;
case ScriptActive of true:begin;
                         status[31].attr:=14+(7 shl 4);
                         status[32].attr:=14+(7 shl 4);
                         status[33].attr:=14+(7 shl 4);
                      end;
                false:begin;
                         status[31].attr:=08+(7 shl 4);
                         status[32].attr:=08+(7 shl 4);
                         status[33].attr:=08+(7 shl 4);
                  end;
                  end;
case AngleMeas of deg:begin;
                         status[51].character:='D';
                         status[52].character:='E';
                         status[53].character:='G';
                       end;
                   rad:begin;
                         status[51].character:='R';
                         status[52].character:='A';
                         status[53].character:='D';
                       end;
                  grad:begin;
                         status[51].character:='G';
                         status[52].character:='R';
                         status[53].character:='A';
                       end;
                   end;
case num_lock of true:begin;
                         status[57].attr:=14+(7 shl 4);
                         status[58].attr:=14+(7 shl 4);
                         status[59].attr:=14+(7 shl 4);
                       end;
                 false:begin;
                         status[57].attr:=08+(7 shl 4);
                         status[58].attr:=08+(7 shl 4);
                         status[59].attr:=08+(7 shl 4);
                   end;
                   end;
case AnsState of true:begin;
                         status[45].attr:=14+(7 shl 4);
                         status[46].attr:=14+(7 shl 4);
                         status[47].attr:=14+(7 shl 4);
                       end;
                 false:begin;
                         status[45].attr:=08+(7 shl 4);
                         status[46].attr:=08+(7 shl 4);
                         status[47].attr:=08+(7 shl 4);
                       end;
                   end;
case insert_status of true:begin;
                         status[63].character:='O';
                         status[64].character:='V';
                         status[65].character:='R';
                       end;
                 false:begin;
                         status[63].character:='I';
                         status[64].character:='N';
                         status[65].character:='S';
                       end;
                   end;
case IsFreeMemory of 1:begin;
                         status[69].attr:=12+(7 shl 4);
                         status[70].attr:=12+(7 shl 4);
                         status[71].attr:=12+(7 shl 4);
                       end;
                  2:begin;
                         status[69].attr:=12+(15 shl 4);
                         status[70].attr:=12+(15 shl 4);
                         status[71].attr:=12+(15 shl 4);
                       end;
                  0:begin;
                         status[69].attr:=08+(7 shl 4);
                         status[70].attr:=08+(7 shl 4);
                         status[71].attr:=08+(7 shl 4);
                       end;
                   end;
GetTime(Hour, Minute, Second, Sec100);
str:=Word2String2(hour);
status[75].character:=str[1];
status[76].character:=str[2];
str:=Word2String2(minute);
status[78].character:=str[1];
status[79].character:=str[2];
putline(1,status);
end;
{begin;
 zmenvypis;
 zmenmiru;
 zmennum;
 zmenans;
 zmenins;
 zmenpamet;
procedure zmencas(Hour, Minute:word);
var str:string;
begin;
str:=Word2String2(hour);
status[75].character:=str[1];
status[76].character:=str[2];
str:=Word2String2(minute);
status[78].character:=str[1];
status[79].character:=str[2];
end;

procedure pisstatus;
end;}

procedure writeclipstat;
begin;
writeln('Aktualni nastaveni schranky:');
if clipboard^.useswin then writeln('Je pouzivana schranka Windows')
                      else writeln('Schranka je emulovana programem')
end;

{Printout ASCII-tabulky}
procedure writeascii;
begin;
writeln(' ASCII Tabulka: (po 32 znacich)');
writeln(''#10''#13''#26'');
writeln(' !"#$%&''()*+,-./0123456789:;<=>?');
writeln('@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_');
writeln('`abcdefghijklmnopqrstuvwxyz{|}~');
writeln('');
writeln('');
writeln('');
writeln('');
end;

{Printout informaci o pameti}
procedure writemem;
begin;
writeln('Informace o pameti:');
writeln('Volna pamet: '+Long2String(memavail)+' bytu = '+Long2String(memavail div 1024)+' kilobytu');
writeln('Pocet promennych: '+Long2String(VariableCount));
writeln('Pocet konstant: '+Long2String(ConstantCount));
writeln('Velikost jedne promenne: '+Long2String(VariableSize)+' bytu');
writeln('Velikost jedne konstanty: '+Long2String(ConstantSize)+' bytu');
end;

{napoveda}
procedure funkceinfo;
begin;
writeln(Titlestart+' Napoveda - POPIS FUNKCI '+TitleEnd);
writeln('  COS, SIN, TG, COTG - goniometricke funkce');
writeln('  SINH, COSH, TGH, COTGH - hyperbolicke funkce');
writeln('  DEG, RAD, GRAD - prevod uhlu ze stupnu, radianu, gradu');
writeln('  ARCCOS, ARCSIN, ARCTG, ARCCOTG - cyklometricke funkce');
writeln('  ARGSINH, ARGCOSH, ARGTGH, ARGCOTGH - hyperbolometricke funkce');
writeln('  EXP, POWER2, POWER10 - mocnina e, 2, 10');
writeln('  SQR, SQRT, CU, CUR - druha mocnina, odmocnina, treti mocnina, odmocnina');
writeln('  AVG, GAV, HAV - prumer aritmeticky, geometricky, harmonicky');
writeln('  MIN, MAX, MINA, MAXA - mensi, vetsi cislo, cislo s mensi, vetsi abs. hodnotou');
writeln('  LN - prirozeny logaritmus');
writeln('  LOG2 - logaritmus o zakladu 2');
writeln('  LOG10 - dekadicky logaritmus');
writeln('  RANDOM - nahodne cislo');
writeln('  TRUNC, ROUND- cela cast cisla, zaokrouhleni');
writeln('  INV - prevracena hodnota (1/x)');
writeln('  FRAC - desetinna cast cisla');
writeln('  ABS - absolutni hodnota');
writeln('  POWER - mocnina [POWER(X,Y)]=[X^Y]');
writeln('  LOG - logaritmus [LOG(X,Y)] logaritmus cisla Y o zakladu X');
writeln('  COMB - pocet kombinaci bez opakovani (kombinacni cislo)');
writeln('  VAR - pocet variaci bez opakovani');
writeln('    priklad:[VAR(K,N)]=pocet variaci k-te tridy z n prvku dtto kombinace');
end;

{napoveda}
procedure info;
begin;
writeln(Titlestart+' MISO Calc verze '+ProgramVersion+' '+ProgramCopyright+' '+TitleEnd);
writeln(#16' Program pouziva');
writeln(' viz ?U nebo ?POUZIVA');
{writeln(' '+Calcul.UnitID+' (C) '+Calcul.unitcopyright+' verze '+Calcul.UnitVersion+' ze dne '+Calcul.UnitRelease);}
writeln(#16' Podpora');
writeln(' Aktualni verze by mela byt dostupna na http://surf.to/miso');
writeln(' Pripominky, namety a dotazy posilejte na mail cihar@iname.com   ');
writeln(' nebo miso_home@xoommail.com');
writeln(#16' Vase navrhy');
writeln(' Pokud si myslite, ze by mely byt pridany dalsi konstanty, funkce  nebo neco');
writeln(' jineho poslete mi popis a dalsi potrebne informace a mozna to bude v dalsi v.');
writeln(#16' Co chci pridelat');
writeln(' - dalsi mody pocitani - ZAKLAD-N (ciselne soustavy), POSLOUPNOSTI (pocitani');
writeln('   s posloupnostmi), RESENI (reseni rovnic), KOMPLEX (komplexni cisla), STAT');
writeln('   (statistika), MATICE, GRAF - a s temito mody souvisejici funkce');
writeln(' - dalsi funkce ve standartnim modu - derivace, integral, suma, prevody');
writeln('   souradnic (polarni-pravouhla)');
writeln(' - ceske fonty');
writeln(' - anglicka verze');
writeln(' - progamovani');
writeln(' - moznost konfigurace');
writeln(' - zmena formatu souboru pro ukladani pameti - nyni je zbytecne velky - BRZO');
writeln(' - moznost pracovat s polem promennych');
writeln(' Proto sledujte zmeny a teste se na nove verze.');
end;

{napoveda}
procedure napovezuses;
begin;
writeln(Titlestart+' MISO Calc verze '+ProgramVersion+' '+ProgramCopyright+' '+TitleEnd);
writeln(#16' Program pouziva tyto unit:');
{writeln(' '+CalculJmeno+' verze '+CalculVerze+' ze dne '+CalculDatum);}
writeln(' '+UCalcul.UnitID+' (C) '+UCalcul.unitcopyright+' verze '+UCalcul.UnitVersion+' ze dne '+UCalcul.UnitRelease);
writeln('   - vyhodnocovani vyrazu');
writeln(' '+UScreen.UnitID+' (C) '+UScreen.unitcopyright+' verze '+UScreen.UnitVersion+' ze dne '+UScreen.UnitRelease);
writeln('   - prace s obrazovkou');
writeln(' '+UKbd.UnitID+' (C) '+UKbd.unitcopyright+' verze '+UKbd.UnitVersion+' ze dne '+UKbd.UnitRelease);
writeln('   - prace s klavesnici');
writeln(' '+UHistory.UnitID+' (C) '+UHistory.unitcopyright+' verze '+UHistory.UnitVersion+' ze dne '+UHistory.UnitRelease);
writeln('   - historie prikazove radky');
writeln(' '+UClip.UnitID+' (C) '+UClip.unitcopyright+' verze '+UClip.UnitVersion+' ze dne '+UClip.UnitRelease);
writeln('   - prace se schrankou (emulace i Windows)');
writeln(' '+UParams.UnitID+' (C) '+UParams.unitcopyright+' verze '+UParams.UnitVersion+' ze dne '+UParams.UnitRelease);
writeln('   - zpracovani prikazove radky');
end;

{napoveda}
procedure napovez;
begin;
writeln(Titlestart+' Napoveda '+TitleEnd);
writeln('');
writeln('Pozn: kdyz je neco v hranatych zavorkach [], je to priklad');
writeln('');
writeln(#16' Co program umi?');
writeln(' Napisete vyraz a program ho vyhodnoti.');
writeln('');
writeln(#16' Co muze obsahovat vyraz?');
writeln(' Vyraz muze obsahovat funkce, operatory, promenne a konstanty');
writeln(' Vice podrobnosti k jednotlivym typum najdete v dalsich castech');
writeln(' napovedy');
writeln('');
writeln(#16' Dalsi casti napovedy:');
writeln(' ?F / ?FUNKCE        ... informace o funkcich');
writeln(' ?P / ?PROMENNE      ... informace o promennych');
writeln(' ?K / ?KONSTANTY     ... informace o konstantach');
writeln(' ?O / ?OPERATORY     ... informace o operatorech');
writeln(' ?V / ?VYHODNOCOVANI ... priority vyhodnocovani vyrazu');
writeln(' vice casti napovedy pod ??');
writeln('');
writeln(#16' Ukonceni programu');
writeln(' Program ukoncite napsanim KONEC, QUIT nebo EXIT');
end;

{napoveda}
procedure napovezclip;
BEGIN;
writeln(Titlestart+' Napoveda - SCHRANKA '+TitleEnd);
writeln('');
writeln(#16' Prace se schrankou');
writeln(' Ctrl+C ... kopiruj (copy)');
writeln(' Ctrl+V ... prilep (paste)');
writeln(' Ctrl+X ... vystrihni (cut)');
writeln(' ');
writeln(#16' Oznaceni bloku');
writeln(' Shift+'#27'/'#26' ... oznaceni znaku vlevo, vpravo');
writeln(' Shift+'#24'/'#25' ... oznaceni radku nahore, dole');
writeln(' Shift+Home ... do konce vyrazu');
writeln(' Shift+End ... do zacatku vyrazu');
writeln(' Shift+Del ... vymaze oznacenou cast');
writeln(' ');
writeln(#16' Dulezite');
writeln(' Pokud je program spusten z Windows, pouziva schranku Windows.');
writeln(' Ze schranky se vklada pouze text do prvniho ASCII znaku 0..31,');
writeln(' nebo 200 znaku. Pokud je obsah schranky vetsi nez 64kB nevlozi se.');
writeln(' Pouzivani schranky Windows se da zapnout/ vypnout prikazy:');
writeln('  zapnout (pokud je mozno): '+ CmdWinClip);
writeln('  vypnout: '+CmdEmuClip);
writeln('  jaka schranka se pouziva: '+CmdClip);
writeln(' ');
END;

{napoveda}
procedure napovezZAKLAD;
BEGIN;
writeln(Titlestart+' Napoveda - CISELNE SOUSTAVY '+TitleEnd);
writeln('');
writeln(#16' Jake zaklady program umi');
writeln(' Vsechny od 2 do 36 - omezeni poctem pismen v abecede.');
writeln('');
writeln(#16' Printout');
writeln(' Printout se ridi podle indikatoru na stavovem radku (viz ?s).');
writeln(' Ty se ovladaji kalvesami (viz ?e)');
writeln(' Printout je pouze pro CELA cisla do velikosti hex: 1 000 000 000 000 000');
writeln(' Pokud neni aktivni zadny prepinac, zobrazi se standartni vysledek');
writeln('');
writeln(#16' Zmena uzivatelske baze');
writeln(' Zmena uzivateske baze pro Printout se provede zapsanim prikazu: '+CmdBase);
writeln('');
writeln(#16' Zadavani');
writeln(' n - cislo v urcitem zakladu, z - zaklad soustavy(cislo 2..36)');
writeln(' $n nebo $ n - cislo v sesnactkove soustave');
writeln(' #hn nebo #h n - cislo v sesnactkove soustave');
writeln(' #dn nebo #d n - cislo v desitkove soustave');
writeln(' #on nebo #o n - cislo v osmickove soustave');
writeln(' #bn nebo #b n - cislo v dvojkove soustave');
writeln(' #z n nebo #z,n - cislo v soustave o zakladu z');
END;

{napoveda}
procedure napovezf;
var b:byte;
begin;
writeln(Titlestart+' Napoveda - FUNKCE '+TitleEnd);
writeln('');
writeln(#16' Funkce, ktere muzete pouzit:');
writeln('Funkce  : COS    SIN    TG    COTG     SINH    COSH    TGH    COTGH');
writeln('Inverzni: ARCCOS ARCSIN ARCTG ARCCOTG  ARGSINH ARGCOSH ARGTGH ARGCOTGH');
writeln('Funkce  : EXP POWER2 POWER10 SQR  CU');
writeln('Inverzni: LN  LOG2   LOG10   SQRT CUR');
writeln('Funkce s zadnym parametrem: RANDOM ');
writeln('Funkce s jednim parametrem: TRUNC ROUND FRAC ABS INV ');
writeln('Funkce s dvema parametry  : LOG POWER VAR COMB MAX MIN MAXA MINA AVG GAV HAV');
writeln('Popis funkci viz ?W');
writeln('');
writeln(#16' Jak psat parametry');
writeln(' Funkce se daji rozdelit podle poctu parametru:');
writeln(' 0 ... neuvadejte zadne parametry ani zavorky');
writeln('       [random]');
writeln(' 1 ... parametry mohou byt uvedeny budto v zavorkach nebo bez zavorek');
writeln('       [sin(5*pi)], [sin pi]=[sin(pi)], [sin pi*2]=[sin(pi)*2]');
writeln(' 2 ... parametry musi byt v zavorce a oddeleny carkou');
writeln('       [power(5,10)]');
end;

{napoveda}
procedure napovezP;
begin;
writeln(Titlestart+' Napoveda - PROMENNE '+TitleEnd);
writeln(#16' Definovani nove promenne, zmena hodnoty promenne');
writeln(' Novou promennou definujete zapsanim jmena promenne, rovnitka a hodnoty, kterou');
writeln(' ma tato promenna mit [a=5]. Jako hodnota muze byt uveden vyraz [a=sin(5pi+1)].');
writeln('');
writeln(#16' Pouziti promennych');
writeln(' Promennou muzete pouzit ve vyrazu, tak ze ji tam napisete [sin(a)].');
writeln(' Pokud potrebujete pouzit nasobek promenne staci psat bez * [5a]');
writeln('');
writeln(#16' Jmeno promenne');
writeln(' Jmeno promenne je jakykoliv tString zacinajici pismenem tzn. muze');
writeln(' obsahovat cisla a dalsi ASCII znaky (viz '+CmdASCII+').');
writeln('');
writeln(#16' Ruseni promenne');
writeln(' Jednu promennou muzete zrusit zapsanim :'+CmdDelete+' jmeno_prom');
writeln(' VSECHNY promenne najednou muzete zrusit zapsanim :'+CmdEmpty);
writeln('');
writeln(#16' Ukladanim a nahravanim promennych');
writeln(' Promenne muzete ulozit/nahrat zapsanim :'+CmdSave+'/'+CmdLoad+' jmeno_souboru');
writeln('');
writeln(#16' Omezeni promennych');
writeln(' Pocet promennych je omezen velikosti volne zakladni pameti');
writeln(' Delka jmena promenne je omezena na '+Long2String(MaximalVariableNameLength));
end;

{napoveda}
procedure napovezPrikazy;
begin;
writeln(Titlestart+' Napoveda - PRIKAZY '+TitleEnd);
writeln(#16' Pamet');
writeln(' Zruseni jedne promenne: '+CmdDelete+' jmeno_prom');
writeln(' Zruseni VSECH promennych: '+CmdEmpty);
writeln(' Ulozeni pameti do souboru: '+CmdSave+' jmeno_souboru');
writeln(' Nahrani pameti ze souboru: '+CmdLoad+' jmeno_souboru');
writeln(' Ulozeni pameti do souboru stare verze: '+CmdSaveOld+' jmeno_souboru');
writeln(' Nahrani pameti ze souboru stare verze: '+CmdLoadOld+' jmeno_souboru');
writeln(#16' Ostatni');
writeln(' Vymazani obrazovky: '+CmdCls);
writeln(' Informace o pameti: '+CmdMem);
writeln(' ASCII tabulka: '+CmdASCII);
writeln(' Schranka: emulace, Windows, stav: '+CmdWinClip+', '+CmdEmuClip+', '+CmdClip);
writeln(' Spusti textovy soubor s prikazy pro MISO Calc: '+CmdExec);
writeln(' Zobrazi uvodni informace: '+CmdStartInfo);
writeln(#16' Parametry programu');
writeln(' Zmena zakladu uzivatelske soustavy: '+CmdBase);
writeln(' Printout v soustave: '+CmdHex+', '+CmdDec+', '+CmdOct+', '+CmdBin+', '+CmdUdf);
writeln(' Uhlova mira: '+CmdDeg+', '+CmdRad+', '+CmdGrad);
writeln(' Pridavani ANS: '+CmdAns);
writeln(' Parametry vypoctu: '+CmdSetDerDelta+', '+CmdSetIntDivision+', '+CmdSetSolDelta+', '+CmdSetSolCycle);
writeln(' Pocet uchovavanych prikazu v historii: '+CmdMaxHistory);
{      CmdNoDisplay:string='&CmdNoDisplay';
      CmdAllDisplay:string='&CmdAllDisplay';
      CmdLogoOff:string='&LOGOOFF';
      CmdPause:string='&PAUSE';
      CmdGet:string='&GET';
      CmdWrite:string='&WRITE';
      CmdAttrib:string='&ATTRIB';}
end;

{napoveda}
procedure ListConstants;
var k:longint;
    b:boolean;
    ch:char;
begin;
writeln(Titlestart+' '+MsgConstantList+' '+TitleEnd);
writeln(MsgConstantDesc);
k:=0;
repeat
write(ConstantName(k+1)+'=');
write(Number2String(GetConstant(ConstantName(k+1),b))+' (');
writeln(InfoConstant(ConstantName(k+1),b)+')');
inc(k);
if (k<ConstantCount)and((k mod (rows - 4))=0) then begin;
                      writeret(PauseStr);
                      if readkey=#27 then exit;
                      writeret(PauseSpa);
                      writeln(Titlestart+' '+MsgConstantList+' '+TitleEnd);
                      writeln(MsgConstantDesc);
                     end
until k>=ConstantCount;
end;

{Printout promennych}
procedure ListVariables;
var k:longint;
    b:boolean;
    ch:char;
begin;
writeln(Titlestart+' '+MsgVariableList+' '+TitleEnd);
if VariableCount>0 then
begin;
writeln(MsgVariableDesc);
k:=0;
repeat
write(VariableName(k+1)+'=');
writeln(Number2String(GetVariable(VariableName(k+1),b)));
inc(k);
if (k<VariableCount)and((k mod (rows - 4))=0) then begin;
                      writeret(PauseStr);
                      if readkey=#27 then exit;
                      writeret(PauseSpa);
                      writeln(Titlestart+' '+MsgVariableList+' '+TitleEnd);
                      writeln(MsgVariableDesc);
                     end
until k>=VariableCount
end
else writeln(MsgNoVariable);
end;

{napoveda}
procedure stavinfo;
begin;
writeln(Titlestart+' Napoveda - STAVOVA RADKA '+TitleEnd);
writeln('');
writeln(#16' Co je na stavove radce');
writeln(' Je zde jmeno a verze programu, datum uvolneni, indikace stavu prepinacu a cas.');
writeln('');
writeln(#16' Popis prepinacu');
writeln(' pozn: aktivni (1) znamena zlute, vypnute (0) sedive');
writeln(' NORM - mod programu (zatim jen NORM :-)');
writeln(' UHDOB - Printout CELYCH cisel: H - sesnactkove (hexadecimal)');
writeln('                             D - desitkove (decimal)');
writeln('                             O - osmickove (octal)');
writeln('                             B - dvojkove (binary)');
writeln('                             U - uzivatelsky zaklad soustavy');
writeln('       - vice informaci viz ?B');
writeln(' ANS - 1: pri zadani operatoru na zacatku radku se prida ANS');
writeln('       0: pri zadani operatoru se nepridava ANS');
writeln(' DEG/RAD/GRA - prepinac uhlove miry');
writeln(' NUM - indikace stavu Num Locku');
writeln(' PRE/VKL - prepisovani/vkladani');
writeln(' MEM - kdyz sviti cervene je malo pameti, kdyz blika, uz je hodne malo pameti');
writeln('');

{writeln(' Na teto radce je videt jake uhlove jednotky program pouziva (DEG/RAD/GRAD),');
writeln(' jestli je aktivni Num Lock (sviti NUM pokud je aktivni), mod prepisovani');
writeln(' nebo vkladani (sviti PRES pokud je prepisovani) a take zde program indikuje,');
writeln(' pokud dochazi volna pamet (rozsviti se cervene pokud zbyva mene nez 64 kB).');
writeln('');
writeln(' Pri sviticim ANS se pri zapsani operatoru jako prvniho znaku prikazu prida');
writeln(' pred tento operator ANS. Pokud je ANS zhasnute pak se pouzije jen operator.');}
end;

{napoveda}
procedure napovezO;
begin;
writeln(Titlestart+' Napoveda - OPERATORY '+TitleEnd);
writeln('');
writeln(#16' Operatory, ktere muzete pouzit:');
writeln(' *   ... nasobeni');
writeln(' /   ... deleni');
writeln(' %   ... celociselne deleni');
writeln(' DIV ... celociselne deleni');
writeln(' \   ... zbytek po celociselnem deleni');
writeln(' MOD ... zbytek po celociselnem deleni');
writeln(' +   ... scitani/znamenko');
writeln(' -   ... odcitani/znamenko');
writeln(' ()  ... zavorky');
writeln(' ^   ... mocnina');
writeln(' ~   ... exponent');
writeln(' =   ... prirazeni');
writeln(' !   ... faktorial (maximalne se da pocitat ze 1754)');
writeln(' $   ... cislo v sesnactkove soustave (viz ?B)');
writeln(' #   ... cislo v soustave o zakladu n (viz ?B)');
end;

{napoveda}
procedure napovezZ;
begin;
writeln(Titlestart+' Napoveda - ZAJIMAVOSTI '+TitleEnd);
writeln('');
writeln(#16' Presnejsi vyjadreni nekterych konstant:');
writeln(' :-)');
writeln('pi = '+pi_125);
writeln('e  = '+e_125);
writeln('');
writeln(#16' Presnost vypoctu');
writeln('Cisla jsou ukladana v Pascalovskem typu extended s presnosti 19-20');
writeln('mist a rozsahem hodnot 3.4e-4932..1.1e4932 plus znamenko. Pri vypoctu');
writeln('je provadena kontrola preteceni, ale podteceni neni kontrolovano. ');
end;

{napoveda}
procedure napovezV;
begin;
writeln(Titlestart+' Napoveda - VYHODNOCOVANI VYRAZU '+TitleEnd);
writeln('');
writeln(#16' Poradi vyhodnocovani vyrazu:');
writeln(' 1. =     (prirazeni)                           ');
writeln(' 2. funkce');
writeln('    5pi,~ (nasobek promenne/konstanty,exponent)');
writeln(' 3. (,)   (zavorky)');
writeln(' 4. !     (faktorial)');
writeln(' 5. +,-   (znamenko)');
writeln(' 6. ^     (mocnina)                    ');
writeln(' 7. *,/,% (nasobeni,deleni,celociselne deleni)  ');
writeln(' 8. +,-   (scitani,odcitani)                    ');
writeln('');
writeln('Operatory stejne priority jsou vyhodnocovany zleva doprava [a/b*c]=[(a/b)*c]');
end;

{napoveda}
procedure napovezx;
begin;
writeln(Titlestart+' Napoveda  - Dalsi casti napovedy '+TitleEnd);
writeln('');
writeln(' ?F / ?FUNKCE        ... informace o funkcich');
writeln(' ?P / ?PROMENNE      ... informace o promennych');
writeln(' ?O / ?OPERATORY     ... informace o operatorech');
writeln(' ?I / ?INFO          ... informace o programu');
writeln(' ?S / ?STAV          ... informace o stavove radce');
writeln(' ?C / ?PRIKAZY       ... informace o prikazech');
writeln(' ?X / ?SCHRANKA      ... informace o schrance (clipboardu)');
writeln(' ?B / ?ZAKLAD        ... zadavani a vypisovani cisel v ruznych soustavach');
writeln(' ?K / ?KONSTANTY     ... vypis konstant');
writeln(' ?L / ?VYPIS         ... vypis promennych');
writeln(' ?W / ?POPIS         ... popis funkci');
writeln(' ?E / ?EDITACE       ... klavesy pri editovani prikazove radky');
writeln(' ?Q / ?KLAVESNICE    ... klavesove zkratky pro funkce');
writeln(' ?V / ?VYHODNOCOVANI ... priority vyhodnocovani vyrazu');
writeln(' ?Z / ?ZAJIMAVOSTI   ... zajimavosti o funkcich, presnost pocitani');
writeln(' ?U / ?POUZIVA       ... informace o unit, ktere program pouziva');
writeln(' ??                  ... to co prave ctete');
end;

{napoveda}
procedure editinfo;
begin;
writeln(Titlestart+' Napoveda  - EDITACE '+TitleEnd);
writeln(#16' Klavesy');
writeln(' '+#26+'         ... pohyb po radce (doprava)');
writeln(' '+#27+'         ... pohyb po radce (doleva)');
writeln(' '+#24+'         ... pohyb po vyrazu nahoru (pokud ma vice radek)');
writeln(' '+#25+'         ... pohyb po vyrazu dolu (pokud ma vice radek)');
writeln(      ' Home      ... pohyb po radce (na zacatek)');
writeln(      ' End       ... pohyb po radce (na konec)');
writeln(      ' PgUp      ... pohyb v historii prikazu (zpet)');
writeln(      ' PgDown    ... pohyb v historii prikazu (dopredu)');
writeln(      ' Insert    ... prepinani vkladani/prepisovani');
writeln(      ' Backspace ... smazani predchoziho znaku');
writeln(      ' Delete    ... smazani aktualniho znaku');
writeln(      ' Tab       ... smazani cele radky');
writeln(      ' F5,F6,F7  ... nastavi jednotku uhlu na stupne, radiany, grady');
writeln(      'Nasledujici klavesy jso prepinace (zapne/vypne):');
writeln(      ' F8        ... vkladani ANS po zadani operatoru na zacatku prikazu');
writeln(      ' Ctrl+F4   ... Printout v uzivatelem definovane soustave (viz ?B)');
writeln(      ' Ctrl+F5   ... Printout v sesnastkove soustave (viz ?B)');
writeln(      ' Ctrl+F6   ... Printout v desitkove soustave (viz ?B)');
writeln(      ' Ctrl+F7   ... Printout v osmickove soustave (viz ?B)');
writeln(      ' Ctrl+F8   ... Printout v dvojkove soustave (viz ?B)');
writeln(      'Prace se schrankou je popsana v ?X');
end;

{napoveda}
procedure klavinfo;
begin;
writeln(Titlestart+' Napoveda - KLAVESOVE ZKRATKY PRO FUNKCE '+TitleEnd);
writeln('');
writeln(' Alt+klavesa  prida na prikazovou radku funkci');
writeln(' A ... ABS - absolutni hodnota');
writeln(' C, S ... COS - kosinus, SIN - sinus');
writeln(' E ... EXP - exponenciala');
writeln(' F ... FRACT - desetinna cast');
writeln(' K ... COMB - kombinace (kombinacni cislo)');
writeln(' L ... LOG - logaritmus (prvni parametr zaklad)');
writeln(' M, O ... SQR, SQRT - druha mocnina, odmocnina');
writeln(' N ... LN - prirozeny logaritmus');
writeln(' P ... POWER - mocnina (prvni parametr na druhy)');
writeln(' R ... RANDOM - nahodne cislo');
writeln(' Q, X ... KONEC');
writeln(' T ... TG - tangens');
writeln(' V ... VAR - variace');
writeln(' Z, = ... ROUND, TRUNC - zaokrouhli, cela cast cisla');
writeln(' - ... ANS - vysledek posledniho vypoctu');
writeln(' 1 ... LOG10 - logaritmus o zakladu 10');
writeln(' 2, 0  ... POWER2, POWER10 - mocnina o zaklady 2, 10');
writeln(' 3, 4  ... MAX, MIN - vetsi, mensi cislo');
writeln(' F5, F6, F7 ... DEG, RAD, GRAD - prevod uhlu');
end;

{procedura obstaravajici editaci prikazove radky}
procedure ctivyraz(var vyraz:tString);
var ch:char;
    x,y,pozice:byte;
    minx,miny:byte;
    hist:byte;
    s:tString;
    {clipboard acessing:}
    startsel,endsel:byte;

{vlozi na aktualni pozici tString co}
procedure vloz(co:string); forward;
procedure pis; forward;

{prepise posledni znak mezerou (po smazani)}
procedure pissmaz(b:byte);
begin;
cursoroff;
textcolor(ColorText);
textbackground(ColorTextBackground);
gotoxy(1+length(s),1);
write(ReturnNChars(' ',b));
cursoron;
end;

{selection+copy+paste+....}
procedure writesel(s:string);
var i:byte;
begin;
if endsel<startsel then begin;i:=endsel;endsel:=startsel;startsel:=i;end;
textcolor(ColorText);
textbackground(ColorTextBackground);
if startsel=0 then write(s) else
if startsel=1 then
begin;
textcolor(ColorSelectedText);
textbackground(ColorSelectedTextBackground);
write(copy(s,1,endsel));
if (endsel-1)<length(s) then
begin;
textcolor(ColorText);
textbackground(ColorTextBackground);
write(copy(s,endsel+1,length(s)-endsel));
end;
end else
begin;
write(copy(s,1,startsel-1));
textcolor(ColorSelectedText);
textbackground(ColorSelectedTextBackground);
write(copy(s,startsel,endsel+1-startsel));
if (endsel-1)<length(s) then
begin;
textcolor(ColorText);
textbackground(ColorTextBackground);
write(copy(s,endsel+1,length(s)-endsel));
end;
end;
end;

procedure selectioncopy;
begin;
if startsel<>0 then clipboard^.put(copy(s,startsel, endsel+1-startsel));
end;

procedure selectionpaste;
begin;
vloz(clipboard^.get);
pis;
end;

procedure selectioncut;
begin;
if startsel<>0 then
begin;
clipboard^.put(copy(s,startsel, endsel+1-startsel));
pozice:=startsel-1;
delete(s,pozice+1,endsel-startsel+1);
pissmaz(endsel-startsel+1);
startsel:=0;
pis;
end;
end;

procedure selectionall;
begin;
startsel:=1;
endsel:=length(s);
pis;
end;

procedure selectionleft;
begin;
if pozice=0 then else
if startsel=0 then begin;
startsel:=pozice;
endsel:=pozice;
dec(pozice);
end else
if (pozice=endsel) then
begin;
  if (startsel<>0)and(endsel=startsel) then startsel:=0;
  dec(endsel);
  dec(pozice);
end else
if ((pozice+1)=startsel) then begin;dec(startsel);dec(pozice);end else
begin;
startsel:=pozice;
endsel:=pozice;
dec(pozice);
end;
pis;
end;

procedure selectionright;
begin;
if pozice=length(s) then else
if startsel=0 then begin;
inc(pozice);
startsel:=pozice;
endsel:=pozice;
end else
if pozice+1=startsel then
begin;
if endsel=startsel then
begin;
startsel:=0;
inc(pozice);
end else
begin;
inc(startsel);
inc(pozice);
end;
end else
if pozice=endsel then
begin;
inc(endsel);
inc(pozice);
end else
begin;
inc(pozice);
startsel:=pozice;
endsel:=pozice;
end;
pis;
end;

procedure selectionup;
begin;
  if (pozice>60) then
  begin;
  if ((pozice+1)=startsel) then begin;startsel:=startsel-60;end else
  if (pozice=endsel) then
  begin;
    if endsel-60<startsel then endsel:=endsel-59 else
    endsel:=endsel-60;
  end else
  begin;endsel:=pozice;startsel:=pozice-59;end;
  pozice:=pozice-60;
  end;
  pis;
end;

procedure selectiondown;
var i:byte;
begin;
  if (pozice<(MaxLength-59))and
     ((pozice+59)<length(s)) then
  begin;
  if (pozice=endsel) then begin;endsel:=endsel+60;end else
  if ((pozice+1)=startsel) then
  begin;
    if startsel+60>endsel then startsel:=startsel+59 else
    startsel:=startsel+60;
  end else
  begin;startsel:=pozice+1;endsel:=pozice+60;end;
  pozice:=pozice+60;
  end;
  pis;
end;

procedure selectionhome;
begin;
if (startsel=0)or((pozice+1)<>startsel) then
begin;
   if (pozice=endsel)and(startsel<>0) then
   begin;endsel:=startsel;startsel:=1;end else
   begin;endsel:=pozice;startsel:=1;end;
end else startsel:=1;
pozice:=0;
pis;
end;

procedure selectionend;
begin;
if (startsel=0)or(pozice<>endsel) then
begin;
   if (pozice+1=startsel)and(startsel<>0) then
   begin;startsel:=endsel+1;endsel:=length(s);end else
   begin;startsel:=pozice+1;endsel:=length(s);end;
end else endsel:=length(s);
pozice:=length(s);
pis;
end;

procedure selectiondelete;
begin;
if startsel<>0 then
begin;
pozice:=startsel-1;
delete(s,pozice+1,endsel-startsel+1);
pissmaz(endsel-startsel+1);
startsel:=0;
pis;
end;
end;

{vypise zadavany tString}
procedure pis;
begin;
cursoroff;
if ((length(s) div 60)+1)>(rows{25}-y) then
begin;
setwin;
scrollup(y-winy2+(length(s) div 60)+1);
y:=winy2-(length(s) div 60)-1;
gotoxy(x,y);
window(x+winx1-1,y+winy1-1,x+59+winx1-1,y+3+winy1-1);
end;
gotoxy(1,1);
writesel(s);
gotoxy(1+pozice,1);
cursoron;
end;

{vypise num mezer}
procedure pismezery(num:byte);
begin;
cursoroff;
gotoxy(1,1);
textcolor(ColorText);
textbackground(ColorTextBackground);
write(ReturnNChars(' ',num));
cursoron;
end;

{nastavi kurzor}
procedure kurzorpos;
begin;
gotoxy(1+pozice,1);
end;

{nastavi typ kurzoru}
procedure kurzortyp;
begin;
if insert_status then setcursor(1,7)
                 else setcursor(6,7);
end;

{vlozi na aktualni pozici tString co}
procedure vloz(co:string);
begin;
if (length(s)+length(co))<=MaxLength then
begin;
cursoroff;
if insert_status then s:=copy(s,1,pozice)+co+copy(s,pozice+length(co)+1,length(s)-pozice-length(co))
else begin;
       s:=copy(s,1,pozice)+co+copy(s,pozice+1,length(s)-pozice);
       if (pozice+1>=startsel)and(pozice<endsel) then endsel:=endsel+length(co) else
       if pozice<startsel then begin;startsel:=startsel+length(co);endsel:=endsel+length(co);end;
     end;
pozice:=pozice+length(co);
cursoron;
pis;
end;
end;

{posledni stavy prepinacu (kvuli stavove radce):}
var lastnum,lastins:boolean;
    lastmem:byte;
    lastmin, Hour, Minute, Second, Sec100: Word;
{zacatek procedury ctivyraz}
begin;
startsel:=0;
x:=wherex;
y:=wherey;
lasty:=y;
gotoxy(x,y);
window(x+winx1-1,y+winy1-1,x+59+winx1-1,y+3+winy1-1);
s:=vyraz;
pozice:=length(s);
hist:=0;
kurzortyp;
lastnum:=num_lock;
zmennum;
lastins:=insert_status;
zmenins;
lastmem:=IsFreeMemory;
zmenans;
zmenvypis;
zmenpamet;
GetTime(Hour, Minute, Second, Sec100);
zmencas(Hour, Minute);
lastmin:=Minute;
pisstatus;
repeat
repeat
if lastnum<>num_lock then
begin;
lastnum:=num_lock;
zmennum;
pisstatus;
end;
if lastins<>insert_status then
begin;
lastins:=insert_status;
zmenins;
pisstatus;
end;
GetTime(Hour, Minute, Second, Sec100);
if minute<>lastmin then
begin;
lastmin:=Minute;
zmencas(Hour, Minute);
pisstatus;
end;
if lastmem<>IsFreeMemory then
begin;
lastmem:=IsFreeMemory;
zmenpamet;
pisstatus;
end;
until keypressed;
ch:=readkey;
if ch<>#0 then hist:=0;
case ch of #8:begin;
                if pozice>1 then begin
                   s:=copy(s,1,pozice-1)+copy(s,pozice+1,length(s)-pozice);
                   if (pozice=endsel)and(startsel=endsel) then startsel:=0 else
                   if (pozice>startsel)and(pozice<=endsel) then dec(endsel) else
                   if pozice<startsel then begin;dec(startsel);dec(endsel);end;
                   dec(pozice);
                   pissmaz(1);
                   pis;
                 end else
                if pozice=1 then begin
                   if (1=startsel)and(endsel>1) then dec(endsel) else
                   if (1=startsel)and(endsel=1) then startsel:=0 else
                   if pozice<startsel then begin;dec(startsel);dec(endsel);end;
                   s:=copy(s,2,length(s));
                   pozice:=0;
                   pissmaz(1);
                   pis;
                 end;
              end;
           #9:begin;
                pismezery(length(s));
                s:='';
                startsel:=0;
                pozice:=0;
                kurzorpos;
              end;
           #1:selectionall;
           #3:selectioncopy;
           #22:selectionpaste;
           #24:selectioncut;
           #13,#10:begin;end;
           #27:begin;
                 pismezery(length(s));
                 s:=CmdLocalQuit;
                 startsel:=0;
                 pozice:=5;
                 pis;
               end;
           #0:begin;
              ch:=readkey;
              if (ch<>#81)and(ch<>#73) then hist:=0;
              case ch of #75:if shift then  selectionleft else
                             begin;
                               if pozice>0 then dec(pozice);
                               kurzorpos;
                             end;
                         #77:if shift then  selectionright else
                             begin;
                               if pozice<length(s) then inc(pozice);
                               kurzorpos;
                             end;
                         #82:begin;
                               kurzortyp;
                             end;
                         #83:if shift then selectiondelete else
                             begin;
                                s:=copy(s,1,pozice)+copy(s,pozice+2,length(s)-pozice-1);
                                if ((pozice+1)>=startsel)and((pozice+1)<=endsel) then dec(endsel) else
                                if pozice<startsel then begin;dec(startsel);dec(endsel);end;
                                pissmaz(1);
                                pis;
                             end;
                         #73:begin;
                                pismezery(length(s));
                                startsel:=0;
                                if hist>CountHistory then hist:=1
                                          else inc(hist);
                                s:=GetHistory(hist);
                                pozice:=length(s);
                                pis;
                             end;
                         #81:begin;
                                pismezery(length(s));
                                startsel:=0;
                                if (hist=0) then hist:=CountHistory{-1}
                                          else dec(hist);
                                s:=GetHistory(hist);
                                pozice:=length(s);
                                pis;
                             end;
                         #72:if shift then  selectionup else
                             begin;
                               if pozice>59 then pozice:=pozice-60;
                               kurzorpos;
                             end;
                         #80:if shift then  selectiondown else
                             begin;
                               if (pozice<(MaxLength-59))and((pozice+59)<length(s)) then pozice:=pozice+60;
                               kurzorpos;
                             end;
                         #71:if shift then selectionhome else
                             begin;
                               pozice:=0;
                               kurzorpos;
                             end;
                         #79:if shift then selectionend else
                             begin;
                               pozice:=length(s);
                               kurzorpos;
                             end;
                         #31:vloz('SIN(');
                         #46:vloz('COS(');
                         #20:vloz('TG(');
                         #18:vloz('EXP(');
                         #38:vloz('LOG(');
                         #49:vloz('LN(');
                         #120:vloz('LOG10(');
                         #121:vloz('POWER2(');
                         #122:vloz('MAX(');
                         #123:vloz('MIN(');
                         #129:vloz('POWER10(');
                         #130:vloz('ANS');
                         #131:vloz('TRUNC(');
                         #24:vloz('SQRT(');
                         #47:vloz('VAR(');
                         #37:vloz('COMB(');
                         #19:vloz('RANDOM');
                         #33:vloz('FRAC(');
                         #50:vloz('SQR(');
                         #44:vloz('ROUND(');
                         #25:vloz('POWER(');
                         #30:vloz('ABS(');
                         #108:vloz('DEG(');
                         #109:vloz('RAD(');
                         #110:vloz('GRAD(');
                         #97:begin;
                               Printout.udf:=not(Printout.udf);
                               zmenvypis;
                               pisstatus;
                             end;
                         #98:begin;
                               Printout.hex:=not(Printout.hex);
                               zmenvypis;
                               pisstatus;
                             end;
                         #99:begin;
                               Printout.dec:=not(Printout.dec);
                               zmenvypis;
                               pisstatus;
                             end;
                         #100:begin;
                               Printout.oct:=not(Printout.oct);
                               zmenvypis;
                               pisstatus;
                             end;
                         #101:begin;
                               Printout.bin:=not(Printout.bin);
                               zmenvypis;
                               pisstatus;
                             end;
                         #63:begin;
                               AngleMeas:=deg;
                               zmenmiru;
                               pisstatus;
                             end;
                         #64:begin;
                               AngleMeas:=rad;
                               zmenmiru;
                               pisstatus;
                             end;
                         #65:begin;
                               AngleMeas:=grad;
                               zmenmiru;
                               pisstatus;
                             end;
                         #66:begin;
                               AnsState:=not(AnsState);
                               zmenans;
                               pisstatus;
                             end;
                         #16,#45:begin;
                                   pismezery(length(s));
                                   startsel:=0;
                                   s:=CmdLocalQuit;
                                   pozice:=5;
                                   pis;
                                 end;
                         end;{case}
              end;
           else
           begin;
            if (pozice=0)and(ch in OperatorsAns)and(AnsState) then vloz('ANS'+ch)
             else
             begin;
              vloz(ch);
              pis;
             end;
          end;
           end;
until ch=#13;
vyraz:=s;
lasty:=y+(length(s)div 60)+1;
setwin;
end;{ctivyraz}

{procedura obstaravajici editaci prikazove radky pri spusteni}
procedure ctivyraz2(var vyraz:tString);
var ch:char;
    x,y,pozice:byte;
    minx,miny:byte;
    hist:byte;
    s:tString;
    {clipboard acessing:}
    startsel,endsel:byte;

{vlozi na aktualni pozici tString co}
procedure vloz(co:string); forward;
procedure pis; forward;

{prepise posledni znak mezerou (po smazani)}
procedure pissmaz(b:byte);
begin;
cursoroff;
textcolor(ColorText);
textbackground(ColorTextBackground);
gotoxy(1+length(s),1);
write(ReturnNChars(' ',b));
cursoron;
end;


{selection+copy+paste+....}
procedure writesel(s:string);
var i:byte;
begin;
if endsel<startsel then begin;i:=endsel;endsel:=startsel;startsel:=i;end;
textcolor(ColorText);
textbackground(ColorTextBackground);
if startsel=0 then write(s) else
if startsel=1 then
begin;
textcolor(ColorSelectedText);
textbackground(ColorSelectedTextBackground);
write(copy(s,1,endsel));
if (endsel-1)<length(s) then
begin;
textcolor(ColorText);
textbackground(ColorTextBackground);
write(copy(s,endsel+1,length(s)-endsel));
end;
end else
begin;
write(copy(s,1,startsel-1));
textcolor(ColorSelectedText);
textbackground(ColorSelectedTextBackground);
write(copy(s,startsel,endsel+1-startsel));
if (endsel-1)<length(s) then
begin;
textcolor(ColorText);
textbackground(ColorTextBackground);
write(copy(s,endsel+1,length(s)-endsel));
end;
end;
end;

procedure selectioncopy;
begin;
if startsel<>0 then clipboard^.put(copy(s,startsel, endsel+1-startsel));
end;

procedure selectionpaste;
begin;
vloz(clipboard^.get);
pis;
end;

procedure selectioncut;
begin;
if startsel<>0 then
begin;
clipboard^.put(copy(s,startsel, endsel+1-startsel));
pozice:=startsel-1;
delete(s,pozice+1,endsel-startsel+1);
pissmaz(endsel-startsel+1);
startsel:=0;
pis;
end;
end;


procedure selectionall;
begin;
startsel:=1;
endsel:=length(s);
pis;
end;

procedure selectionleft;
begin;
if pozice=0 then else
if startsel=0 then begin;
startsel:=pozice;
endsel:=pozice;
dec(pozice);
end else
if (pozice=endsel) then
begin;
  if (startsel<>0)and(endsel=startsel) then startsel:=0;
  dec(endsel);
  dec(pozice);
end else
if ((pozice+1)=startsel) then begin;dec(startsel);dec(pozice);end else
begin;
startsel:=pozice;
endsel:=pozice;
dec(pozice);
end;
pis;
end;

procedure selectionright;
begin;
if pozice=length(s) then else
if startsel=0 then begin;
inc(pozice);
startsel:=pozice;
endsel:=pozice;
end else
if pozice+1=startsel then
begin;
if endsel=startsel then
begin;
startsel:=0;
inc(pozice);
end else
begin;
inc(startsel);
inc(pozice);
end;
end else
if pozice=endsel then
begin;
inc(endsel);
inc(pozice);
end else
begin;
inc(pozice);
startsel:=pozice;
endsel:=pozice;
end;
pis;
end;

procedure selectionup;
begin;
  if (pozice>60) then
  begin;
  if ((pozice+1)=startsel) then begin;startsel:=startsel-60;end else
  if (pozice=endsel) then
  begin;
    if endsel-60<startsel then endsel:=endsel-59 else
    endsel:=endsel-60;
  end else
  begin;endsel:=pozice;startsel:=pozice-59;end;
  pozice:=pozice-60;
  end;
  pis;
end;

procedure selectiondown;
var i:byte;
begin;
  if (pozice<(MaxLength-59))and
     ((pozice+59)<length(s)) then
  begin;
  if (pozice=endsel) then begin;endsel:=endsel+60;end else
  if ((pozice+1)=startsel) then
  begin;
    if startsel+60>endsel then startsel:=startsel+59 else
    startsel:=startsel+60;
  end else
  begin;startsel:=pozice+1;endsel:=pozice+60;end;
  pozice:=pozice+60;
  end;
  pis;
end;

procedure selectionhome;
begin;
if (startsel=0)or((pozice+1)<>startsel) then
begin;
   if (pozice=endsel)and(startsel<>0) then
   begin;endsel:=startsel;startsel:=1;end else
   begin;endsel:=pozice;startsel:=1;end;
end else startsel:=1;
pozice:=0;
pis;
end;

procedure selectionend;
begin;
if (startsel=0)or(pozice<>endsel) then
begin;
   if (pozice+1=startsel)and(startsel<>0) then
   begin;startsel:=endsel+1;endsel:=length(s);end else
   begin;startsel:=pozice;endsel:=length(s);end;
end else endsel:=length(s);
pozice:=length(s);
pis;
end;

procedure selectiondelete;
begin;
if startsel<>0 then
begin;
pozice:=startsel-1;
delete(s,pozice+1,endsel-startsel+1);
pissmaz(endsel-startsel+1);
startsel:=0;
pis;
end;
end;



{vypise zadavany tString}
procedure pis;
begin;
cursoroff;
if ((length(s) div 60)+1)>(rows{25}-y) then
begin;
setwin;
scrollup(y-winy2+(length(s) div 60)+1);
y:=winy2-(length(s) div 60)-1;
gotoxy(x,y);
window(x+winx1-1,y+winy1-1,x+59+winx1-1,y+3+winy1-1);
end;
gotoxy(1,1);
writesel(s);
gotoxy(1+pozice,1);
cursoron;
end;

{vypise num mezer}
procedure pismezery(num:byte);
begin;
cursoroff;
gotoxy(1,1);
textcolor(ColorText);
textbackground(ColorTextBackground);
write(ReturnNChars(' ',num));
cursoron;
end;

{nastavi kurzor}
procedure kurzorpos;
begin;
gotoxy(1+pozice,1);
end;

{nastavi typ kurzoru}
procedure kurzortyp;
begin;
if insert_status then setcursor(1,7)
                 else setcursor(6,7);
end;

{vlozi na aktualni pozici tString co}
procedure vloz(co:string);
begin;
if (length(s)+length(co))<=MaxLength then
begin;
cursoroff;
if insert_status then s:=copy(s,1,pozice)+co+copy(s,pozice+length(co)+1,length(s)-pozice-length(co))
else begin;
       s:=copy(s,1,pozice)+co+copy(s,pozice+1,length(s)-pozice);
       if (pozice+1>=startsel)and(pozice<endsel) then endsel:=endsel+length(co) else
       if pozice<startsel then begin;startsel:=startsel+length(co);endsel:=endsel+length(co);end;
     end;
pozice:=pozice+length(co);
cursoron;
pis;
end;
end;

{posledni stavy prepinacu (kvuli stavove radce):}
var lastnum,lastins:boolean;
    lastmem:byte;
    lastmin, Hour, Minute, Second, Sec100: Word;
{zacatek procedury ctivyraz2}
begin;
startsel:=0;
x:=wherex;
y:=wherey;
lasty:=y;
gotoxy(x,y);
window(x+winx1-1,y+winy1-1,x+59+winx1-1,y+3+winy1-1);
s:=vyraz;
pozice:=length(s);
hist:=0;
kurzortyp;
lastnum:=num_lock;
zmennum;
lastins:=insert_status;
zmenins;
lastmem:=IsFreeMemory;
zmenans;
zmenvypis;
zmenpamet;
GetTime(Hour, Minute, Second, Sec100);
zmencas(Hour, Minute);
lastmin:=Minute;
pisstatus;
repeat
repeat
if lastnum<>num_lock then
begin;
lastnum:=num_lock;
zmennum;
pisstatus;
end;
if lastins<>insert_status then
begin;
lastins:=insert_status;
zmenins;
pisstatus;
end;
GetTime(Hour, Minute, Second, Sec100);
if minute<>lastmin then
begin;
lastmin:=Minute;
zmencas(Hour, Minute);
pisstatus;
end;
if lastmem<>IsFreeMemory then
begin;
lastmem:=IsFreeMemory;
zmenpamet;
pisstatus;
end;
until keypressed;
ch:=readkey;
if ch<>#0 then hist:=0;
case ch of #8:begin;
                if pozice>1 then begin
                   s:=copy(s,1,pozice-1)+copy(s,pozice+1,length(s)-pozice);
                   if (pozice=endsel)and(startsel=endsel) then startsel:=0 else
                   if (pozice>startsel)and(pozice<=endsel) then dec(endsel) else
                   if pozice<startsel then begin;dec(startsel);dec(endsel);end;
                   dec(pozice);
                   pissmaz(1);
                   pis;
                 end else
                if pozice=1 then begin
                   if (1=startsel)and(endsel>1) then dec(endsel) else
                   if (1=startsel)and(endsel=1) then startsel:=0 else
                   if pozice<startsel then begin;dec(startsel);dec(endsel);end;
                   s:=copy(s,2,length(s));
                   pozice:=0;
                   pissmaz(1);
                   pis;
                 end;
              end;
           #9:begin;
                pismezery(length(s));
                s:='';
                startsel:=0;
                pozice:=0;
                kurzorpos;
              end;
           #1:selectionall;
           #3:selectioncopy;
           #22:selectionpaste;
           #24:selectioncut;
           #13,#10,#27:begin;end;
           #0:begin;
              ch:=readkey;
              if (ch<>#81)and(ch<>#73) then hist:=0;
              case ch of #75:if shift then  selectionleft else
                             begin;
                               if pozice>0 then dec(pozice);
                               kurzorpos;
                             end;
                         #77:if shift then  selectionright else
                             begin;
                               if pozice<length(s) then inc(pozice);
                               kurzorpos;
                             end;
                         #82:begin;
                               kurzortyp;
                             end;
                         #83:if shift then selectiondelete else
                             begin;
                                s:=copy(s,1,pozice)+copy(s,pozice+2,length(s)-pozice-1);
                                if ((pozice+1)>=startsel)and((pozice+1)<=endsel) then dec(endsel) else
                                if pozice<startsel then begin;dec(startsel);dec(endsel);end;
                                pissmaz(1);
                                pis;
                             end;
                         #73:begin;
                                pismezery(length(s));
                                startsel:=0;
                                if hist>CountHistory then hist:=1
                                          else inc(hist);
                                s:=GetHistory(hist);
                                pozice:=length(s);
                                pis;
                             end;
                         #81:begin;
                                pismezery(length(s));
                                startsel:=0;
                                if (hist=0) then hist:=CountHistory{-1}
                                          else dec(hist);
                                s:=GetHistory(hist);
                                pozice:=length(s);
                                pis;
                             end;
                         #72:if shift then  selectionup else
                             begin;
                               if pozice>59 then pozice:=pozice-60;
                               kurzorpos;
                             end;
                         #80:if shift then  selectiondown else
                             begin;
                               if (pozice<(MaxLength-59))and((pozice+59)<length(s)) then pozice:=pozice+60;
                               kurzorpos;
                             end;
                         #71:if shift then selectionhome else
                             begin;
                               pozice:=0;
                               kurzorpos;
                             end;
                         #79:if shift then selectionend else
                             begin;
                               pozice:=length(s);
                               kurzorpos;
                             end;
                         #31:vloz('SIN(');
                         #46:vloz('COS(');
                         #20:vloz('TG(');
                         #18:vloz('EXP(');
                         #38:vloz('LOG(');
                         #49:vloz('LN(');
                         #120:vloz('LOG10(');
                         #121:vloz('POWER2(');
                         #122:vloz('MAX(');
                         #123:vloz('MIN(');
                         #129:vloz('POWER10(');
                         #130:vloz('ANS');
                         #131:vloz('TRUNC(');
                         #24:vloz('SQRT(');
                         #47:vloz('VAR(');
                         #37:vloz('COMB(');
                         #19:vloz('RANDOM');
                         #33:vloz('FRAC(');
                         #50:vloz('SQR(');
                         #44:vloz('ROUND(');
                         #25:vloz('POWER(');
                         #30:vloz('ABS(');
                         #108:vloz('DEG(');
                         #109:vloz('RAD(');
                         #110:vloz('GRAD(');
                         #97:begin;
                               Printout.udf:=not(Printout.udf);
                               zmenvypis;
                               pisstatus;
                             end;
                         #98:begin;
                               Printout.hex:=not(Printout.hex);
                               zmenvypis;
                               pisstatus;
                             end;
                         #99:begin;
                               Printout.dec:=not(Printout.dec);
                               zmenvypis;
                               pisstatus;
                             end;
                         #100:begin;
                               Printout.oct:=not(Printout.oct);
                               zmenvypis;
                               pisstatus;
                             end;
                         #101:begin;
                               Printout.bin:=not(Printout.bin);
                               zmenvypis;
                               pisstatus;
                             end;
                         #63:begin;
                               AngleMeas:=deg;
                               zmenmiru;
                               pisstatus;
                             end;
                         #64:begin;
                               AngleMeas:=rad;
                               zmenmiru;
                               pisstatus;
                             end;
                         #65:begin;
                               AngleMeas:=grad;
                               zmenmiru;
                               pisstatus;
                             end;
                         #66:begin;
                               AnsState:=not(AnsState);
                               zmenans;
                               pisstatus;
                             end;
                         end;{case}
              end;
           else
           begin;
            if (pozice=0)and(ch in OperatorsAns)and(AnsState) then vloz('ANS'+ch)
             else
             begin;
              vloz(ch);
              pis;
             end;
          end;
           end;
until ch=#13;
vyraz:=s;
lasty:=y+(length(s)div 60)+1;
setwin;
end;{ctivyraz2}

{vypise informace o zmene pameti}
procedure piszmenupameti;
begin;
if Printout.allowed then
begin;
               writeln('Zmena v pameti: '+LastChange);
               writeln('Celkem promennych: '+Long2String(VariableCount));
end;
end;

{vypise chybu pri praci s pameti}
procedure pischybupameti;
begin;
case MemoryError of
     ErrVariableNotFound: pis_ch(MsgError+' pri praci s pameti: '+'promenna neexistuje: '+ErrorString);
     ErrBadName      : pis_ch(MsgError+' pri praci s pameti: '+'spatne jmeno promenne: '+ErrorString);
     ErrLowMemory       : pis_ch(MsgError+' pri praci s pameti: '+'nedostatek pameti (viz ?M)');
     ErrIsConstant      : pis_ch(MsgError+' pri praci s pameti: '+'toto jmeno je jiz pouzito pro konstantu: '+ErrorString);
     ErrIsFunction         : pis_ch(MsgError+' pri praci s pameti: '+'toto jmeno je jiz pouzito pro funkci: '+ErrorString);
     ErrTooLongName   : pis_ch(MsgError+' pri praci s pameti: '+'prilis dlouhe jmeno pro promennou: '+ErrorString);
     ErrNoVariableFound: pis_ch(MsgError+' pri praci s pameti: '+'zadna promena nenalezena');
     else pis_ch(MsgError+' pri praci s pameti: '+'neznama chyba');
     end;
end;

{zjisti jestli byl zadan prikaz, nebo napoveda
 a provede prikaz}
procedure CheckInput(var WhatToCheck:tString);
var zjist:tString;
    tb:byte;
    tl:longint;
    Code: Integer;
    ScriptActiveTemp:boolean;
    Result:tRealNumber;
begin;
if WhatToCheck='' then begin;
{               WhatToCheck:=GetHistory(1);
               writeln('Nebyl zadan zadny vyraz. Pouzivam minuly vyraz.');
               writeln(MsgCalculate+' '+WhatToCheck);}
               writeln(MsgNoExpression);
               WhatToCheck:=PromptInputDone;
             end else
             begin;
               if WhatToCheck<> GetHistory(1) then PutHistory(WhatToCheck);
             end;
if WhatToCheck=PromptInputDone then else
if WhatToCheck='?' then begin;napovez;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?F' then begin;napovezF;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?P' then begin;napovezP;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?K' then begin;ListConstants;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?O' then begin;napovezO;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?V' then begin;napovezV;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='??' then begin;napovezX;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?Z' then begin;napovezz;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?I' then begin;info;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?W' then begin;funkceinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?E' then begin;editinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?Q' then begin;KLAVinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?S' then begin;STAVinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?L' then begin;ListVariables;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?C' then begin;napovezprikazy;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?B' then begin;napovezZAKLAD;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?X' then begin;napovezclip;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?U' then begin;napovezuses;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?POUZIVA' then begin;napovezuses;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?SCHRANKA' then begin;napovezclip;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?ZAKLAD' then begin;napovezZAKLAD;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?PRIKAZY' then begin;napovezprikazy;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?VYPIS' then begin;ListVariables;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?STAV' then begin;STAVinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?KLAVESNICE' then begin;KLAVinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?EDITACE' then begin;editinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?POPIS' then begin;funkceinfo;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?INFO' then begin;info;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?FUNKCE' then begin;napovezF;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?PROMENNE' then begin;napovezP;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?KONSTANTY' then begin;ListConstants;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?OPERATORY' then begin;napovezO;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?VYHODNOCOVANI' then begin;napovezV;WhatToCheck:=PromptInputDone;end else
if StringUpCase(WhatToCheck)='?ZAJIMAVOSTI' then begin;napovezz;WhatToCheck:=PromptInputDone;end else
if WhatToCheck[1]='?' then begin;pis_ch(MsgError+': neznamy parametr napovedy');WhatToCheck:=PromptInputDone;end else
if WhatToCheck=':-)' then begin;pis_ch(#1);WhatToCheck:=PromptInputDone;end else
if WhatToCheck=':o)' then begin;pis_ch(#2);WhatToCheck:=PromptInputDone;end else
if WhatToCheck=':-@' then begin;pis_ch('Everything OK?');WhatToCheck:=PromptInputDone;end else
if WhatToCheck='(-_-)' then begin;pis_ch('Nothing special for secret users...');WhatToCheck:=PromptInputDone;end else
if WhatToCheck='2B|^2B' then
   begin;
     pis_ch('To be or not to be?');
     pis_ch('I really don''t know');
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdListC)))=CmdListC then
   begin;ListConstants;WhatToCheck:=PromptInputDone;end else
if StringUpCase(copy(WhatToCheck,1,length(CmdList)))=CmdList then
   begin;ListVariables;WhatToCheck:=PromptInputDone;end else
if StringUpCase(copy(WhatToCheck,1,length(CmdSetDerDelta)))=CmdSetDerDelta then
   begin;
     zjist:=copy(WhatToCheck,length(CmdSetDerDelta)+1,length(WhatToCheck)-length(CmdSetDerDelta));
     Result:=Evaluate(zjist,b);
     if b then Delta:=abs(Result)
          else pis_ch(MsgError+': '+MsgBadNumber);
     writeln('Zvetseni/zmenseni promenne pri numerickem derivovani: '+Number2String(Delta));
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdSetIntDivision)))=CmdSetIntDivision then
   begin;
     zjist:=copy(WhatToCheck,length(CmdSetIntDivision)+1,length(WhatToCheck)-length(CmdSetIntDivision));
     Result:=Evaluate(zjist,b);
     if b then IntgDivs:=abs(Result)
          else pis_ch(MsgError+': '+MsgBadNumber);
     writeln('Pocet deleni pro pocitani integralu: '+Number2String(IntgDivs));
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdSetSolDelta)))=CmdSetSolDelta then
   begin;
     zjist:=copy(WhatToCheck,length(CmdSetSolDelta)+1,length(WhatToCheck)-length(CmdSetSolDelta));
     Result:=Evaluate(zjist,b);
     if b then MaxDelta:=abs(Result)
          else pis_ch(MsgError+': '+MsgBadNumber);
     WhatToCheck:=PromptInputDone;
     writeln('Maximalni rozdil mezi dvemi mezivysledky pri reseni rovnice: '+Number2String(MaxDelta));
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdMaxHistory)))=CmdMaxHistory then
   begin;
     zjist:=copy(WhatToCheck,length(CmdMaxHistory)+1,length(WhatToCheck)-length(CmdMaxHistory));
     Result:=Evaluate(zjist,b);
     if b then
     begin;
       if abs(Result)<=256 then SetCountHistory(abs(round(Result)))
                             else pis_ch(MsgError+': prilis velke cislo');
     end else pis_ch(MsgError+': '+MsgBadNumber);
     writeln('Maximalni pocet uchovavanych prikazu: '+Long2String(MaxHistoryCount));
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdSetSolCycle)))=CmdSetSolCycle then
   begin;
     zjist:=copy(WhatToCheck,length(CmdSetSolCycle)+1,length(WhatToCheck)-length(CmdSetSolCycle));
     Result:=Evaluate(zjist,b);
     if b then
     begin;
       if abs(Result)<=2147483647 then MaxCycles:=abs(round(Result))
                             else pis_ch(MsgError+': prilis velke cislo');
     end else pis_ch(MsgError+': '+MsgBadNumber);
     writeln('Maximalni pocet cyklu pri reseni rovnice: '+Long2String(MaxCycles));
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdAns)))=CmdAns then
   begin;
     zjist:=copy(WhatToCheck,length(CmdAns)+1,length(WhatToCheck)-length(CmdAns));
     zjist:=StringNoSpaceBracket(zjist);
     if zjist='' then AnsState:=not(AnsState) else
     if zjist[1]='1' then AnsState:=true
                     else AnsState:=false;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdDeg)))=CmdDeg then
   begin;
     AngleMeas:=deg;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdGrad)))=CmdGrad then
   begin;
     AngleMeas:=grad;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdRad)))=CmdRad then
   begin;
     AngleMeas:=rad;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdHex)))=CmdHex then
   begin;
     zjist:=copy(WhatToCheck,length(CmdHex)+1,length(WhatToCheck)-length(CmdHex));
     zjist:=StringNoSpaceBracket(zjist);
     if zjist='' then Printout.hex:=not(Printout.hex) else
     if zjist[1]='1' then Printout.hex:=true
                     else Printout.hex:=false;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdDec)))=CmdDec then
   begin;
     zjist:=copy(WhatToCheck,length(CmdDec)+1,length(WhatToCheck)-length(CmdDec));
     zjist:=StringNoSpaceBracket(zjist);
     if zjist='' then Printout.dec:=not(Printout.dec) else
     if zjist[1]='1' then Printout.dec:=true
                     else Printout.dec:=false;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdOct)))=CmdOct then
   begin;
     zjist:=copy(WhatToCheck,length(CmdOct)+1,length(WhatToCheck)-length(CmdOct));
     zjist:=StringNoSpaceBracket(zjist);
     if zjist='' then Printout.oct:=not(Printout.oct) else
     if zjist[1]='1' then Printout.oct:=true
                     else Printout.oct:=false;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdBin)))=CmdBin then
   begin;
     zjist:=copy(WhatToCheck,length(CmdBin)+1,length(WhatToCheck)-length(CmdBin));
     zjist:=StringNoSpaceBracket(zjist);
     if zjist='' then Printout.bin:=not(Printout.bin) else
     if zjist[1]='1' then Printout.bin:=true
                     else Printout.bin:=false;
     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdUdf)))=CmdUdf then
   begin;
     zjist:=copy(WhatToCheck,length(CmdUdf)+1,length(WhatToCheck)-length(CmdUdf));
     zjist:=StringNoSpaceBracket(zjist);
     val(zjist,tb,Code);
     if zjist='' then Printout.udf:=not(Printout.udf) else
     if zjist[1]='0' then Printout.udf:=false
     else
     if Code=0 then begin;Printout.udf:=true;Printout.base:=tb;end
                    else Printout.udf:=true;

     updatestat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdExec)))=CmdExec then
   begin;
     zjist:=copy(WhatToCheck,length(CmdExec)+1,length(WhatToCheck)-length(CmdExec));
     zjist:=StringNoSpaceBracket(zjist);
     ScriptActiveTemp:=ScriptActive;
     if ExecuteScript(zjist)=1 then WhatToCheck:=CmdLocalQuit
                                 else WhatToCheck:=PromptInputDone;
     ScriptActive:=ScriptActiveTemp;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdClip)))=CmdClip then
   begin;
     writeclipstat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdStartInfo)))=CmdStartInfo then
   begin;
     writestartinfo;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdEmuClip)))=CmdEmuClip then
   begin;
     Clipboard^.force(0);
     writeclipstat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdWinClip)))=CmdWinClip then
   begin;
     Clipboard^.force(1);
     writeclipstat;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdBase)))=CmdBase then
   begin;
     zjist:=copy(WhatToCheck,length(CmdBase)+1,length(WhatToCheck)-length(CmdBase));
     Result:=Evaluate(zjist,b);
     if b then
     begin;
       if (abs(Result)>=2)and(abs(Result)<=36) then Printout.base:=abs(round(Result))
                             else pis_ch(MsgError+': cislo musi byt od 2 do 36');
     end else pis_ch(MsgError+': '+MsgBadNumber);
     writeln('Zaklad uzivatelskeho vypisu: '+Long2String(Printout.base));
     WhatToCheck:=PromptInputDone;
{     writeln('Zmena zakladu uzivatelskeho vypisu');
     writeln('Nyni je nastaveno: '+Long2String(Printout.base));
     write('Zadejte zaklad od 2 do 36: ');
     readln(tb);
     if (tb<2)or(tb>36) then writeln('Spatny zaklad') else Printout.base:=tb;
     writeln('Nyni je nastaveno: '+Long2String(Printout.base));
     s:=PromptInputDone;}
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdASCII)))=CmdASCII then
   begin;
     writeascii;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdMem)))=CmdMem then
   begin;
     writemem;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdCls)))=CmdCls then
   begin;
     clrscr;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdDelete)))=CmdDelete then
   begin;
     zjist:=copy(WhatToCheck,length(CmdDelete)+1,length(WhatToCheck)-length(CmdDelete));
     zjist:=StringNoSpaceBracket(zjist);
     DeleteVariable(zjist);
     if (MemoryError_=ErrOK)and(MemoryChange) then piszmenupameti
                                                  else begin;
                                                       ErrorString:=zjist;
                                                       pischybupameti;
                                                       end;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdSave)))=CmdSave then
   begin;
     zjist:=copy(WhatToCheck,length(CmdSave)+1,length(WhatToCheck)-length(CmdSave));
     zjist:=StringNoSpaceBracket(zjist);
     writeln('Ukladam pamet:');
     tb:=SaveVariables(zjist,true);
     case tb of
      ErrOK              :writeln('Pamet ulozena do souboru '+zjist);
      ErrVariableNotFound:pis_ch(MsgError+': promena nenalezena');
      ErrBadName         :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrLowMemory       :pis_ch(MsgError+': malo pameti na nahrani souboru');
      ErrIsConstant      :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrIsFunction      :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrTooLongName     :pis_ch(MsgError+': prilis dlouhe jmeno promenne v souboru '+zjist);
      ErrFileNotFound    :pis_ch(MsgError+': soubor '+zjist+' nenalezen');
      ErrReading         :pis_ch(MsgError+': chyba pri cteni ze souboru '+zjist);
      ErrWriting         :pis_ch(MsgError+': chyba pri zapisu do souboru '+zjist);
      ErrBlockID         :pis_ch(MsgError+': spatne ID vloku v souboru '+zjist);
      ErrFileID          :pis_ch(MsgError+': spathe ID souboru '+zjist);
      ErrPosition        :pis_ch(MsgError+': spatna pozice v souboru '+zjist);
      ErrDataSize        :pis_ch(MsgError+': spatna velikost dat v souboru '+zjist);
      end;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdEmpty)))=CmdEmpty then
   begin;
     write('Opravdu zrusit vsechny promenne [Ano/Ne]? ');
     if upcase(readkey)='A' then
     begin;
     writeln('Ano');
     writeret('Rusim pamet...');
     DeleteAllVariables;
     MemoryChange;
     writeln('Pamet zrusena ');
     end else
     writeln('Ne');
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdLoadDBF)))=CmdLoadDBF then
   begin;
     zjist:=copy(WhatToCheck,length(CmdLoadDBF)+1,length(WhatToCheck)-length(CmdLoadDBF));
     zjist:=StringUpCase(StringNoSpaceBracket(zjist));
     if Pos('.',zjist)<1 then zjist:=zjist+'.DBF';
     writeln('Nahravam pamet:');
     tb:=LoadDBFVariables(zjist,true,tl);
     case tb of
      ErrOK              :writeln('Pamet nahrana ze souboru '+zjist);
      ErrVariableNotFound:pis_ch(MsgError+': promena nenalezena');
      ErrBadName         :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrLowMemory       :pis_ch(MsgError+': malo pameti na nahrani souboru');
      ErrIsConstant      :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrIsFunction      :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrTooLongName     :pis_ch(MsgError+': prilis dlouhe jmeno promenne v souboru '+zjist);
      ErrFileNotFound    :pis_ch(MsgError+': soubor '+zjist+' nenalezen');
      ErrReading         :pis_ch(MsgError+': chyba pri cteni ze souboru '+zjist);
      ErrWriting         :pis_ch(MsgError+': chyba pri zapisu do souboru '+zjist);
      ErrBlockID         :pis_ch(MsgError+': spatne ID vloku v souboru '+zjist);
      ErrFileID          :pis_ch(MsgError+': spatne ID souboru '+zjist);
      ErrPosition        :pis_ch(MsgError+': spatna pozice v souboru '+zjist);
      ErrDataSize        :pis_ch(MsgError+': spatna velikost dat v souboru '+zjist);
      ErrNameNotFound    :pis_ch(MsgError+': jmeno promenne nenalezeno v '+zjist);
      ErrValueNotFound   :pis_ch(MsgError+': hodnota promenne nenalezena v '+zjist);
      ErrBadValue        :pis_ch(MsgError+': spatna hodnota promenne v '+zjist);
      end;
     if tl>0 then pis_ch(MsgError+': pocet spatnych jmen promennych v souboru '+zjist+': '+Long2String(tl));
     WhatToCheck:=PromptInputDone;
     if MemoryChange then
        begin;
           writeln('Zmena v pameti: '+LastChange);
           writeln('Celkem promennych: '+Long2String(VariableCount));
        end;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdLoad)))=CmdLoad then
   begin;
     zjist:=copy(WhatToCheck,length(CmdLoad)+1,length(WhatToCheck)-length(CmdLoad));
     zjist:=StringNoSpaceBracket(zjist);
     writeln('Nahravam pamet:');
     tb:=LoadVariables(zjist,true);
     case tb of
      ErrOK              :writeln('Pamet nahrana ze souboru '+zjist);
      ErrVariableNotFound:pis_ch(MsgError+': promena nenalezena ');
      ErrBadName         :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrLowMemory       :pis_ch(MsgError+': malo pameti na nahrani souboru ');
      ErrIsConstant      :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrIsFunction      :pis_ch(MsgError+': spatne jmeno promenne v souboru '+zjist);
      ErrTooLongName     :pis_ch(MsgError+': prilis dlouhe jmeno promenne v souboru '+zjist);
      ErrFileNotFound    :pis_ch(MsgError+': soubor '+zjist+' nenalezen');
      ErrReading         :pis_ch(MsgError+': chyba pri cteni ze souboru '+zjist);
      ErrWriting         :pis_ch(MsgError+': chyba pri zapisu do souboru '+zjist);
      ErrBlockID         :pis_ch(MsgError+': spatne ID vloku v souboru '+zjist);
      ErrFileID          :pis_ch(MsgError+': spathe ID souboru '+zjist);
      ErrPosition        :pis_ch(MsgError+': spatna pozice v souboru '+zjist);
      ErrDataSize        :pis_ch(MsgError+': spatna velikost dat v souboru '+zjist);
      end;
     WhatToCheck:=PromptInputDone;
     if MemoryChange then
        begin;
           writeln('Zmena v pameti: '+LastChange);
           writeln('Celkem promennych: '+Long2String(VariableCount));
        end;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdSaveOld)))=CmdSaveOld then
   begin;
     zjist:=copy(WhatToCheck,length(CmdSaveOld)+1,length(WhatToCheck)-length(CmdSaveOld));
     zjist:=StringNoSpaceBracket(zjist);
     writeln('Ukladam pamet:');
     case SaveVariables_old(zjist,true) of 1:pis_ch(MsgError+': chyba pri zakladani souboru '+zjist);
                                          2:pis_ch(MsgError+': chyba pri zapisovani hlavicky souboru '+zjist);
                                   3:pis_ch(MsgError+': chyba pri zapisovani promennych do souboru '+zjist);
                                   0:writeln('Pamet ulozena do souboru '+zjist);
                                   end;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdLoadOld)))=CmdLoadOld then
   begin;
     zjist:=copy(WhatToCheck,length(CmdLoadOld)+1,length(WhatToCheck)-length(CmdLoadOld));
     zjist:=StringNoSpaceBracket(zjist);
     writeln('Nahravam pamet:');
     case loadvariables_old(zjist,true) of 1:pis_ch(MsgError+': chyba pri otevirani souboru '+zjist);
                                     2:pis_ch(MsgError+': chyba pri cteni hlavicky souboru '+zjist);
                                     3:pis_ch(MsgError+': chyba pri cteni promennych ze souboru '+zjist);
                                     4:pis_ch(MsgError+': chyba pri cteni souboru '+zjist);
                                     5:pis_ch(MsgError+': chyba pri ukladani do pameti ze souboru '+zjist);
                                     0:writeln('Pamet nahrana ze souboru '+zjist);
                                     end;
     WhatToCheck:=PromptInputDone;
     if MemoryChange then
        begin;
           writeln('Zmena v pameti: '+LastChange);
           writeln('Celkem promennych: '+Long2String(VariableCount));
        end;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdAllowResult)))=CmdAllowResult then
   begin;
     Printout.allowed:=true;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdForbidResult)))=CmdForbidResult then
   begin;
     Printout.allowed:=false;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdLogoOff)))=CmdLogoOff then
   begin;
     DisplayLogoOnQuit:=false;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdLogoOn)))=CmdLogoOn then
   begin;
     DisplayLogoOnQuit:=true;
     WhatToCheck:=PromptInputDone;
   end else
if WhatToCheck[1]='@' then
   begin;
     pis_ch(MsgError+': neznamy prikaz');
     WhatToCheck:=PromptInputDone;
   end else
if WhatToCheck[1]='&' then
   begin;
     pis_ch(MsgError+': tyto prikazy jsou povoleny pouze v programech');
     WhatToCheck:=PromptInputDone;
   end;
end;{CheckInput}

{vypise chybu}
procedure pischybu;
begin;
if (ErrorPosition mod 60) = 0
then pis_ch(MsgError+' na '+Long2String(ErrorPosition)+ReturnNChars(' ',65-length(Long2String(ErrorPosition)))+{'^'}#24)
else
pis_ch(MsgError+' na '+Long2String(ErrorPosition)+
       ReturnNChars(' ',(ErrorPosition mod 60)+5-length(Long2String(ErrorPosition)))+{'^'}#24);
if ErrorNumber=ErrMemory then
begin;
pischybupameti;
end else pis_ch('Popis chyby: '+Error2String);
end;

{vypise vysledek}
procedure WriteResultNoCheck(const Result:tRealNumber);
begin;
with Printout do
begin;
if ((Result<>int(Result))or(abs(Result)>MaximalBaseOut))or
   ((hex or dec or oct or bin or udf)=false) then writeln(MsgResult+' '+Number2String(Result)) else
begin;
writeln (MsgResult+' ');
if Result>=0.0 then
   begin;
     if udf then writeln('udf ('+Number2Dec(base)+'): '+Number2Udf(Result,base));
     if hex then writeln('hex: '+Number2Hex(Result));
     if dec then writeln('dec: '+Number2Dec(Result));
     if oct then writeln('oct: '+Number2Oct(Result));
     if bin then writeln('bin: '+Number2Bin(Result));
   end else
if Result<0.0 then
   begin;
     if udf then writeln('udf ('+Number2Dec(base)+'): -'+Number2Udf(-Result,base));
     if hex then writeln('hex: -'+Number2Hex(-Result));
     if dec then writeln('dec: -'+Number2Dec(-Result));
     if oct then writeln('oct: -'+Number2Oct(-Result));
     if bin then writeln('bin: -'+Number2Bin(-Result));
   end;
end;
if WasSolve then writeln('Vysledna hodnota vyrazu po SOLVE: '+Number2String(SolveResult))
end;
end;

{vypise vysledek}
procedure WriteResult(const Result:tRealNumber);
begin;
if Printout.allowed then WriteResultNoCheck(Result);
end;

function FileExists(FileName: String): Boolean;
var
 F: file;
begin
 {$I-}
 Assign(F, FileName);
 FileMode := 0;
 Reset(F);
 Close(F);
 {$I+}
 FileExists := (IOResult = 0) and (FileName <> '');
end;

function ExecuteScript(filename:string):byte;
const display:boolean=true;
var f:text;
    LoadedLine:tString;
    Result:tRealNumber;

procedure getvyraz(var vyr:tString);
begin;
if not(eof(f)) then readln(f,vyr)
               else vyr:=PromptInputEOF;
end;

{zjisti jestli byl zadan prikaz, nebo napoveda
 a provede prikaz}
procedure CheckProgram(var WhatToCheck:tString);
var zjist,zjist2,s2:string;
    Result1, Result2: tRealNumber;
    tb:byte;
    code:integer;
begin;
if WhatToCheck='' then WhatToCheck:=PromptInputDone else
if StringUpCase(copy(WhatToCheck,1,length(CmdIf)))=CmdIf then
   begin;
     zjist:=copy(WhatToCheck,length(CmdIf)+1,length(WhatToCheck)-length(CmdIf));
     if pos(CmdThen,StringUpCase(zjist))> 0 then
     begin;
     if pos('>=',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('>=',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('>=',zjist)+2,pos(CmdThen,StringUpCase(zjist))-2-pos('>=',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1>=Result2;
     end else
     if pos('<=',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('<=',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('<=',zjist)+2,pos(CmdThen,StringUpCase(zjist))-2-pos('<=',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1<=Result2;
     end else
     if pos('=>',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('=>',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('=>',zjist)+2,pos(CmdThen,StringUpCase(zjist))-2-pos('=>',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1>=Result2;
     end else
     if pos('=<',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('=<',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('=<',zjist)+2,pos(CmdThen,StringUpCase(zjist))-2-pos('=<',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1<=Result2;
     end else
     if pos('<>',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('<>',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('<>',zjist)+2,pos(CmdThen,StringUpCase(zjist))-2-pos('<>',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1<>Result2;
     end else
     if pos('=',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('=',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('=',zjist)+1,pos(CmdThen,StringUpCase(zjist))-1-pos('=',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=(Result1=Result2);
     end else
     if pos('<',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('<',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('<',zjist)+1,pos(CmdThen,StringUpCase(zjist))-1-pos('<',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1<Result2;
     end else
     if pos('>',zjist)>0 then
     begin;
        zjist2:=copy(zjist,1,pos('>',zjist)-1);
        Result1:=Evaluate(zjist2,b);
        zjist2:=copy(zjist,pos('>',zjist)+1,pos(CmdThen,StringUpCase(zjist))-1-pos('>',zjist));
        if b then Result2:=Evaluate(zjist2,b);
        if b then b:=Result1>Result2;
     end else pis_ch(MsgError+': Chybi relacni operator (>,<,=)');
     if (pos(CmdElse,StringUpCase(zjist))> 0)and(not(b)) then
     begin;
       WhatToCheck:=copy(zjist,pos(CmdElse,StringUpCase(zjist))+5,length(zjist)-4-pos(CmdElse,StringUpCase(zjist)));
       CheckProgram(WhatToCheck);
       if (WhatToCheck<>PromptInputFirst)and(WhatToCheck<>PromptInputDone) then CheckInput(WhatToCheck);
       if (WhatToCheck<>PromptInputFirst)and(WhatToCheck<>PromptInputDone) then
       begin;
       writeret(MsgCalculating);
       Result1:=Evaluate(WhatToCheck,b);
       if b then
        begin;
              WriteResult(Result1);
         end else
         pischybu;
       end;
     end else
     begin;
     if b then
     begin;
       if (pos(CmdElse,StringUpCase(zjist))> 0) then
        WhatToCheck:=copy(zjist,pos(CmdThen,StringUpCase(zjist))+5,
                              pos(CmdElse,StringUpCase(zjist))-5-pos(CmdThen,StringUpCase(zjist)));
       if (pos(CmdElse,StringUpCase(zjist))= 0) then
        WhatToCheck:=copy(zjist,pos(CmdThen,StringUpCase(zjist))+5,length(zjist));
       CheckProgram(WhatToCheck);
       if (WhatToCheck<>PromptInputFirst)and(WhatToCheck<>PromptInputDone) then CheckInput(WhatToCheck);
       if (WhatToCheck<>PromptInputFirst)and(WhatToCheck<>PromptInputDone) then
       begin;
       writeret(MsgCalculating);
       Result1:=Evaluate(WhatToCheck,b);
       if b then
        begin;
              WriteResult(Result1);
         end else
         pischybu;
       end;
     end;
     end;
     end else pis_ch(MsgError+': Chybi '+CmdThen);
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdGoto)))=CmdGoto then
   begin;
     zjist:=copy(WhatToCheck,length(CmdGoto)+1,length(WhatToCheck)-length(CmdGoto));
     zjist:=StringNoSpaceBracket(zjist);
     reset(f);
     repeat
     repeat
     readln(f,s2);
     until (StringUpCase(copy(s2,1,length(CmdLabel)))=CmdLabel)or(eof(f));
     zjist2:=copy(s2,length(CmdLabel)+1,length(s2)-length(CmdLabel));
     zjist2:=StringNoSpaceBracket(zjist2);
     until (StringUpCase(zjist2)=StringUpCase(zjist))or(eof(f));
     if (StringUpCase(zjist2)<>StringUpCase(zjist)) then pis_ch(MsgError+': Spatny parametr prikazu '+CmdGoto);
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdEnd)))=CmdEnd then
   begin;
     while not(eof(f)) do readln(f);
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdLabel)))=CmdLabel then
   begin;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdAttrib)))=CmdAttrib then
   begin;
     zjist:=copy(WhatToCheck,length(CmdAttrib)+1,length(WhatToCheck)-length(CmdAttrib));
     zjist:=StringNoSpaceBracket(zjist);
     val(zjist,tb,Code);
     if zjist='' then ColorCmdWrite:=7 else
     if Code=0 then ColorCmdWrite:=tb;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdDisplay)))=CmdDisplay then
   begin;
     WhatToCheck:=copy(WhatToCheck,length(CmdDisplay)+1,length(WhatToCheck)-length(CmdDisplay));
     Result1:=Evaluate(WhatToCheck,b);
     if b then WriteResultNoCheck(Result1)
          else pischybu;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdWrite)))=CmdWrite then
   begin;
     zjist:=copy(WhatToCheck,length(CmdWrite)+2,length(WhatToCheck)-length(CmdWrite)-1);
     writelnattr(zjist,ColorCmdWrite);
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdGet)))=CmdGet then
   begin;
     zjist:=copy(WhatToCheck,length(CmdGet)+1,length(WhatToCheck)-length(CmdGet));
     zjist:=StringNoSpaceBracket(zjist);
     repeat
       clearbuffer;
       textcolor(ColorPrompt);
       textbackground(ColorTextBackground);
       write(MsgPrompt+' ');
       textcolor(ColorText);
       textbackground(ColorTextBackground);
       WhatToCheck:='';
       ctivyraz2(WhatToCheck);
       writeret(MsgCalculating);
       Result1:=Evaluate(WhatToCheck,b);
       if b then WriteResult(Result1)
            else pischybu;
     until b;
     IntoMemory(zjist,Result1);
      if MemoryChange then
              piszmenupameti;

     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdWait)))=CmdWait then
   begin;
     zjist:=copy(WhatToCheck,length(CmdWait)+1,length(WhatToCheck)-length(CmdWait));
     Result1:=Evaluate(zjist,b);
     if b then
     begin;
       if (abs(Result1)<=65535) then wait(0,abs(round(Result1))) else
       if (abs(Result1)<=((65536.0*65536.0)-1.0)) then wait(abs(round(Result1) div 65536),abs(round(Result1) mod 65536))
                             else pis_ch(MsgError+': prilis velke cislo');
     end else pis_ch(MsgError+': '+MsgBadNumber);
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdPause)))=CmdPause then
   begin;
     pause;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdNoDisplay)))=CmdNoDisplay then
   begin;
     display:=false;
     WhatToCheck:=PromptInputDone;
   end else
if StringUpCase(copy(WhatToCheck,1,length(CmdAllDisplay)))=CmdAllDisplay then
   begin;
     display:=true;
     WhatToCheck:=PromptInputDone;
   end else
if WhatToCheck[1]='&' then WhatToCheck:=copy(WhatToCheck,2,length(WhatToCheck)-1);
end;{CheckProgram}

begin;
ScriptActive:=true;
zmenprg;
if not(fileexists(filename)) then
   if pos('.',filename)<1 then filename:=filename+DefaultExtension;
if fileexists(filename) then
begin;
assign(f,filename);
reset(f);
textcolor(ColorPrompt);
textbackground(0);
if Printout.allowed then writeln('Spoustim program '+filename);
textcolor(ColorText);
textbackground(0);
LoadedLine:=PromptInputFirst;
display:=true;
repeat
updatestat;
if (LoadedLine<>PromptInputFirst)and(LoadedLine<>PromptInputDone)and(LoadedLine[1]<>';')and
   ((upcase(LoadedLine[1])+upcase(LoadedLine[2])+upcase(LoadedLine[3]))<>'REM') then
begin;
      writeret(MsgCalculating);
      Result:=Evaluate(LoadedLine,b);
      if b then
       begin;
         if MemoryChange then
            piszmenupameti else
            WriteResult(Result);
       end else
       pischybu;
end;     {LoadedLine<>PromptInputDone a LoadedLine<>PromptInputFirst}
getvyraz(LoadedLine);
if LoadedLine<>PromptInputEOF then
begin;
if LoadedLine[1]<>'&' then
if display then
  begin;
  textbackground(ColorTextBackground);
  textcolor(ColorPrompt);
  write('Nahran prikaz: ');
  textcolor(ColorText);
  writeln(LoadedLine);
  end;

  textcolor(ColorText);
  CheckProgram(LoadedLine);
  if (LoadedLine<>PromptInputFirst)and(LoadedLine<>PromptInputDone) then CheckInput(LoadedLine);
end else
begin;
  textbackground(ColorTextBackground);
  textcolor(ColorPrompt);
  if Printout.allowed then writeln('Konec souboru '+filename);
end;
until {(eof(f))or}(LoadedLine=PromptInputEOF)or
      (StringShort(LoadedLine,CmdExit)=CmdExit)or
      (StringShort(LoadedLine,CmdQuit)=CmdQuit)or
      (StringShort(LoadedLine,CmdLocalQuit)=CmdLocalQuit);
close(f);
if (StringShort(LoadedLine,CmdExit)=CmdExit)or
   (StringShort(LoadedLine,CmdQuit)=CmdQuit)or
   (StringShort(LoadedLine,CmdLocalQuit)=CmdLocalQuit) then ExecuteScript:=1
                                                                                        else ExecuteScript:=0;
end else begin;pis_ch(MsgError+': soubor '+filename+' neexistuje');ExecuteScript:=0;end;
ScriptActive:=false;
zmenprg;
end;

function runparamfiles:byte;
var i,j:byte;
begin;
j:=0;
for i:=1 to paramnum do
begin;
  if paramarray[i].divtype=divspace then
     j:=ExecuteScript(paramarray[i].value);
  if j=1 then break;
end;
runparamfiles:=j;
end;

procedure DoPrompt;
var UserInput:tString;
    Result:tRealNumber;
begin;
textcolor(7);
textbackground(0);
UserInput:=PromptInputFirst;
repeat
if (UserInput<>PromptInputFirst)and(UserInput<>PromptInputDone)and(UserInput<>CmdQuit) then
begin;
      writeret(MsgCalculating);
      Result:=Evaluate(UserInput,b);
      if b then
       begin;
         if MemoryChange then
            piszmenupameti else
            WriteResult(Result);
       end else
       pischybu;
end;     {UserInput<>PromptInputDone a UserInput<>PromptInputFirst}
clearbuffer;
if (UserInput<>CmdQuit) then
begin;
textcolor(ColorPrompt);
textbackground(0);
write(MsgPrompt+' ');
textcolor(7);
textbackground(0);
UserInput:='';
ctivyraz(UserInput);
CheckInput(UserInput);
end;
until (StringShort(UserInput,CmdExit)=CmdExit)or
      (StringShort(UserInput,CmdQuit)=CmdQuit)or
      (StringShort(UserInput,CmdLocalQuit)=CmdLocalQuit);
end; {DoPrompt}

procedure DoParamsQuote;
var Params2Parse,ParsedParam:byte;
    Result:tRealNumber;
begin;
Params2Parse:=paramquote;
ParsedParam:=1;
textcolor(ColorTextBackground);
textcolor(ColorInfo);
textbackground(0);
writeln('');
writeln(ProgramName+' '+MsgVersion+' '+ProgramVersion+' '+ProgramCopyright+' '+MsgRelease+' '+ProgramRelease);
writeln(MsgUses+' '+UCalcul.UnitID+
        ' (C) '+UCalcul.unitcopyright+' '+
        MsgVersion+' '+UCalcul.UnitVersion+' ('+UCalcul.UnitRelease+')');
textcolor(ColorText);
while Params2Parse>0 do
begin;
while (paramarray[ParsedParam].divtype<>divquote1)and(paramarray[ParsedParam].divtype<>divquote2) do inc(ParsedParam);
writeln(MsgCalculate+' '+paramarray[ParsedParam].value);
writeret(MsgCalculating);
Result:=Evaluate(paramarray[ParsedParam].value,b);
if b then
   begin;
     if MemoryChange then piszmenupameti
                     else WriteResult(Result);
   end else pischybu;
dec(Params2Parse);
inc(ParsedParam);
end;
endsmall;
halt(ErrorNumber);
end; {DoParamsQuote}

procedure InitSettings;
begin;
setpausestr(MsgWaitForKey);
SumTableMsg:=' Pocet          Hodnota                Soucet';
SumTablePause:=22;
SumTableWriteln:=Writeln;
SumTablePauseProc:=Pause;
lasty:=1;
Clipboard:=new(pclipboardstring,init);
init_kbd;
set_blinking(true);
FileCreatorString:=ProgramFileCreator; {file creator string used while saving files}
end; {InitSettings}

procedure DrawScreen;
begin;
setwin;
pisstatus;
clrscr;
writestartinfo;
textcolor(ColorPrompt);
textbackground(0);
end;

{main program}
begin;
InitSettings;
if paramquote>0 then DoParamsQuote;
DrawScreen;
if fileexists(InitScript) then
begin;
  if ExecuteScript(InitScript)=1 then WasQuit:=true else WasQuit:=false;
end;
if paramspace>0 then begin;if runparamfiles=1 then WasQuit:=true{useless - else WasQuit:=WasQuit or false};end;
if not(WasQuit) then DoPrompt;
if DisplayLogoOnQuit then proglogo
                     else endsmall;
end.