{$N+,E+}
{****************************************************************************
 *           } Unit UData;{ (c) 1999 Michal Cihar                           *
 ****************************************************************************}
interface
const MaxLength    =239; {delka vyrazu - 4 radky po 60 znacich}
      MaxFunctions   =65; {pocet definovanych funkci}
      MinMemory    =64*1024; {64 kB pameti by melo zustat volne}
      AbsMinMemory =12*1024; {12 kB je opravdu nutne minimum!!!}

      {casto pouzivana cisla:}
      Pi_pul      :extended=pi/2;
      pi_2        :extended=pi*2;
      pi_10       :extended=pi*10;
      pi_100      :extended=pi*100;
      pi_1000     :extended=pi*1000;
      pi_10000    :extended=pi*10000;


type
     tRealNumber = extended; {format cisla}
     tString     = string[MaxLength]; {vstupni tString}
     tExpression = record
                         Expression:tString;
                         Position:byte;
                       end;
     tFunctionDef= procedure (var Result : tRealNumber;var Express:tExpression);
     tFunction     = Record
                         Name:string[15];
                         Calculate:tFunctionDef;
                   end; {definovane funkce}
     tAngleMeas = (deg,rad,grad); {v jake uhlove mire pocitat}

const
     {prace s chybami:}
     ErrOK               = 0;
     ErrBadExponent      = 1;
     ErrNoExponent       = 2;
     ErrNotVariable      = 3;
     ErrNotConstant      = 4;
     ErrNotNumber        = 5;
     ErrNoBracketEnd     = 6;
     ErrNoBracketStart   = 7;
     ErrNoComma          = 8;
     ErrDiv0             = 9;
     ErrBadPower         =10;
     ErrBadLog           =11;
     ErrBadLogBase       =12;
     ErrBadTan           =13;
     ErrBadRoot          =14;
     ErrBadCoTan         =15;
     ErrBadArcSin        =16;
     ErrBadArcCos        =17;
     ErrBadName          =18;
     ErrMemory           =19;
     ErrNoValue          =20;
     ErrBadFactorial     =21;
     ErrBadCoTanH        =22;
     ErrBadArgCosH       =23;
     ErrBadArgTanH       =24;
     ErrBadArgCoTanH     =25;
     ErrBadComb          =26;
     ErrBadVar           =27;
     ErrUnexpectedEnd    =28;
     ErrOverflow         =29;
     ErrBadBase          =30;
     ErrBaseOutOfRange   =31;
     ErrNoOperation      =32;
     ErrCanNotBeSolved   =33;
     ErrBadExpression    =34;
     ErrBadSum           =35;
     ErrBadIntg          =36;
     {od 100 jsou chyby se soubory
      SouborNeexistuje    = 101;
      ChybaCteni          = 102;
      ChybaZapis          = 103;
      ChybaIDBlok         = 104;
      ChybaIDSoubor       = 105;
      ChybaPozice         = 106;
      ChybaDataVel        = 107;}
     CanBeInSolver:set of byte=
     [ErrOK
     ,ErrDiv0
     ,ErrBadPower
     ,ErrBadLog
     ,ErrBadLogBase
     ,ErrBadTan
     ,ErrBadRoot
     ,ErrBadCoTan
     ,ErrBadArcSin
     ,ErrBadArcCos
     ,ErrBadFactorial
     ,ErrBadCoTanH
     ,ErrBadArgCosH
     ,ErrBadArgTanH
     ,ErrBadArgCoTanH
     ,ErrBadComb
     ,ErrBadVar
     ,ErrOverflow
     ,ErrBadBase
     ,ErrBaseOutOfRange
     ,ErrBadSum
     ,ErrBadIntg];

     {kdo ma zajem o presnejsi cisla:}
     pi_125='3.1415926535897932384626433832795028841971693993751058209749445'
            +'923078164062862089986280348253421170679821480865132823066470938';
     e_125= '2.7182818284590452353602874713526624977572470936999595749669676'
           + '277240766303535475945713821785251664274274663919320030599218174';

     AngleMeas:tAngleMeas=deg; {v jake uhlove mire jsou zadavana cisla}

     Delta:tRealNumber=1e-10; {used for numeric derivation}
     MaxCycles:longint=1000;   {for equation solver}
     MaxDelta:tRealNumber=1e-16; {for equation solver}
     IntgDivs:tRealNumber=100; {for numeric integration - number of divisions}

     Divisors:set of char=[' ','\',';','*','/','^','+','=','-','%','(',')',',','!'];
     {cim jsou oddelena "slova" v zadavanem retezci}
     Operators:set of char=['\','*','/','^','+','-','%','(','!'];
     {Operators}
     OperatorsAns:set of char=['\','*','/','^','+','-','%','!'];
     {Operators}

     WasSolve:boolean=false;
     SolveResult:tRealNumber=0.0;

var FunctionData:array[1..MaxFunctions] of tFunction; {z tohoto pole se zjistuje
                                                funkce, ktera se provede}
    ErrorNumber,ErrorPosition:byte; {ErrN chyby, pozice chyby}
    ErrorString:string; {retezec, ktery zpusobil chybu}

function Error2String:string; {popis chyby}
function GetErrorString(ErrN:byte):string;
function IsFunction(const s:string):boolean; {zjisteni, jestli je s funkce}
function FromRad(What:tRealNumber):tRealNumber; {prevod z radu na aktualni uhlovou miru}
function ToRad(What:tRealNumber):tRealNumber; {prevod z aktualni uhlove miry na rady}
function IsFreeMemory:byte; {jestli je dostatek pameti (konstanty MinMemory a
                           AbsMinMemory)}

implementation

function IsFreeMemory:byte;
begin;
if (memavail>MinMemory) then IsFreeMemory:=0 else
if (memavail>AbsMinMemory) then IsFreeMemory:=1 else
                               IsFreeMemory:=2;
end;

function GetErrorString(ErrN:byte):string;
begin;
case ErrN of
     ErrOK               :GetErrorString:='Zadna chyba'+ErrorString;
     ErrBadExponent      :GetErrorString:='Chybny exponent: '+ErrorString;
     ErrNoExponent       :GetErrorString:='Chybi exponent'+ErrorString;
     ErrNotVariable      :GetErrorString:=''+ErrorString+' neni promenna';
     ErrNotConstant      :GetErrorString:=''+ErrorString+' neni konstanta';
     ErrNotNumber        :GetErrorString:=''+ErrorString+' neni cislo';
     ErrNoBracketEnd     :GetErrorString:='Chybi konec zavorky'+ErrorString;
     ErrNoBracketStart   :GetErrorString:='Chybi zacatek zavorky'+ErrorString;
     ErrNoComma          :GetErrorString:='Chybi carka'+ErrorString;
     ErrDiv0             :GetErrorString:='Deleni nulou'+ErrorString;
     ErrBadPower         :GetErrorString:='Chybny parametr mocniny'+ErrorString;
     ErrBadLog           :GetErrorString:='Chybny parametr logaritmu: '+ErrorString;
     ErrBadLogBase       :GetErrorString:='Chybny zaklad logaritmu: '+ErrorString;
     ErrBadTan           :GetErrorString:='Chybny parametr tangens: '+ErrorString;
     ErrBadRoot          :GetErrorString:='Chybny parametr odmocniny: '+ErrorString;
     ErrBadCoTan         :GetErrorString:='Chybny parametr cotangens: '+ErrorString;
     ErrBadArcSin        :GetErrorString:='Chybny parametr arcus sinus: '+ErrorString;
     ErrBadArcCos        :GetErrorString:='Chybny parametr arcus cosinus: '+ErrorString;
     ErrBadName          :GetErrorString:='Spatne jmeno funkce/promenne/konstany :'+ErrorString;
     ErrMemory           :GetErrorString:='Chyba v pameti'+ErrorString;
     ErrNoValue          :GetErrorString:='Chybi hodnota'+ErrorString;
     ErrBadFactorial     :GetErrorString:='Chybny parametr faktorialu: '+ErrorString;
     ErrBadCoTanH        :GetErrorString:='Chybny parametr hyp cotangens: '+ErrorString;
     ErrBadArgCosH       :GetErrorString:='Chybny parametr hyp argcosinus: '+ErrorString;
     ErrBadArgTanH       :GetErrorString:='Chybny parametr hyp argtangens: '+ErrorString;
     ErrBadArgCoTanH     :GetErrorString:='Chybny parametr hyp argcotangens: '+ErrorString;
     ErrBadComb          :GetErrorString:='Chybny parametr kombinace: '+ErrorString;
     ErrBadVar           :GetErrorString:='Chybny parametr variace: '+ErrorString;
     ErrUnexpectedEnd    :GetErrorString:='Neocekavany konec vyrazu'+ErrorString;
     ErrOverflow         :GetErrorString:='Prilis velke cislo - doslo k preteceni velikosti cisla'+ErrorString;
     ErrBadBase          :GetErrorString:='Spatny zaklad pro cislo '+ErrorString;
     ErrBaseOutOfRange   :GetErrorString:='Zaklad soustavy mimo moznosti programu'+ErrorString;
     ErrNoOperation      :GetErrorString:='Chybi operator'+ErrorString;
     ErrCanNotBeSolved   :GetErrorString:='Nejde vyresit: '+ErrorString;
     ErrBadExpression    :GetErrorString:='Neplatny vyraz: '+ErrorString;
     ErrBadSum           :GetErrorString:='Spatne parametry sumy'+ErrorString;
     ErrBadIntg          :GetErrorString:='Spatne parametry integralu'+ErrorString;
{     SouborNeexistuje    :GetErrorString:='Soubor neexistuje';
     ChybaCteni          :GetErrorString:='Chyba pri cteni';
     ChybaZapis          :GetErrorString:='Chyba pri zapisu';
     ChybaIDBlok         :GetErrorString:='Chybne ID bloku';
     ChybaIDSoubor       :GetErrorString:='Chybne ID souboru';
     ChybaPozice         :GetErrorString:='Chybna pozice';
     ChybaDataVel        :GetErrorString:='Chybna velikost dat';}
     else GetErrorString:='Neznama chyba: '+ErrorString;
     end;
end;

function Error2String:string;
begin;
Error2String:=GetErrorString(ErrorNumber);
end;

function IsFunction(const s:string):boolean;
var b:byte;
    Result:boolean;
begin;
Result:=false;
for b:=1 to MaxFunctions do
    if FunctionData[b].Name=s then
    begin;
      Result:=true;
      break;
    end;
IsFunction:=Result;
end;

function FromRad(What:tRealNumber):tRealNumber;
begin;
case AngleMeas of deg:FromRad:=(What/pi)*180;
                   rad:FromRad:=What;
                   grad:FromRad:=(What/pi)*200;
                   end;
end;

function ToRad(What:tRealNumber):tRealNumber;
begin;
case AngleMeas of deg:ToRad:=(What/180)*pi;
                   rad:ToRad:=What;
                   grad:ToRad:=(What/200)*pi;
                   end;
end;

begin;
end.