{****************************************************************************
 *           } Unit UHistory;{ (c) 1999 Michal Cihar                        *
 ****************************************************************************}

interface
uses udata;
const UnitID='UHistory';
      UnitCopyright='1999 Michal Cihar';
      UnitVersion='1.2';
      UnitRelease='4.2.1999';
const MaxHistoryCount:byte=20; {maximalni Count polozek historie}
function GetHistory(n:byte):tString; {vrati n-tou polozku historie}
procedure PutHistory(s:tString); {vlozi do historie}
function CountHistory:longint; {Count prvku historie}
procedure SetCountHistory(b:byte);

implementation
var
  oldexit : pointer;
type pHistory=^tHistory;
     tHistory=record
             Value:tString;
             Prev,Next:pHistory;
            end;
     lHistory=record
             First,Last:pHistory;
             Count:longint;
            end;
var History:lHistory;

function CountHistory:longint;
begin;
CountHistory:=History.Count;
end;

function GetHistory(n:byte):tString;
var i:byte;
    temp:pHistory;
begin;
if (n>0)and(n<=History.Count) then
begin;
temp:=History.First;
if n>1 then
for i:= 1 to (n-1) do
    temp:=temp^.Next;
GetHistory:=temp^.Value;
end
else GetHistory:='';

end;

procedure DeleteLast;
var temp:pHistory;
begin;
temp:=History.Last;
History.Last^.Prev^.Next:=nil;
History.Last:=History.Last^.Prev;
if temp<> nil then dispose(temp);
dec(History.Count);
end;

procedure PutHistory(s:tString);
var temp:pHistory;
begin;
if History.Count>=MaxHistoryCount then DeleteLast;
if MaxAvail<sizeof(tHistory) then DeleteLast;
inc(History.Count);
new(temp);
temp^.Value:=s;
if History.First=nil then History.Last:=temp
                     else History.First^.Prev:=temp;
temp^.Next:=History.First;
temp^.Prev:=nil;
History.First:=temp;
end;

procedure InitHistory;
begin;
with History do
begin;
 First:=nil;
 Last:=nil;
 Count:=0;
end;
end;

procedure CancelHistory;
begin;
while History.Count>0 do
begin;
DeleteLast;
end;
end;

procedure SetCountHistory(b:byte);
begin;
while History.Count>b do
begin;
DeleteLast;
end;
MaxHistoryCount:=b;
end;

procedure exit_uhistory;far;
begin
  exitproc := oldexit;
  CancelHistory;
end;

begin;
{nastavime uvolneni pameti pri ukonceni programu:}
  oldexit  := exitproc;
  exitproc := @exit_uhistory;
{inicializace}
  InitHistory;
end.
