{$N+,E+}
{****************************************************************************
 *           } Unit UMath;{ (c) 1999 Michal Cihar                           *
 ****************************************************************************}
{nejake matematicke funkce bez prime podpory Pascalem

To co je v assembleru vola interface Borlandu ke koprocesoru, pokud
neni pouzije se emulace - toto napsal Norbert Juffa

kontrola jestli dojde k preteceni pri operaci
}


INTERFACE

FUNCTION Tan (X: EXTENDED): EXTENDED;

FUNCTION Log10 (X: EXTENDED): EXTENDED;

FUNCTION Log2  (X: EXTENDED): EXTENDED;

FUNCTION Power10 (X: EXTENDED): EXTENDED;

FUNCTION Power2 (X: EXTENDED): EXTENDED;

FUNCTION Power (X, Y: EXTENDED): EXTENDED;

FUNCTION realmod (X, Y: EXTENDED): EXTENDED;

FUNCTION realdiv (X, Y: EXTENDED): EXTENDED;

function realround(x:extended):extended;

function realtrunc(x:extended):extended;

function realceil(x:extended):extended;

function realValid(x:extended;b:extended):extended;

function Sign(Number : extended) : extended;

function Fact(Number : extended) : extended;

{kontrola jestli dojde pri dane operaci k preteceni:}
function testp10(Number : extended):boolean; {10^number}
function testnas(X, Y: EXTENDED):boolean;    {x*y}
function testp(X, Y: EXTENDED):boolean;      {x^y}
function testp2(Number : extended):boolean;  {2^number}
function testexp(Number : extended):boolean; {e^number}
function testsqr(Number : extended):boolean; {number^2}
function testfac(Number : extended):boolean; {number!}
function testscit(X, Y: EXTENDED):boolean;   {x+y}


IMPLEMENTATION

function testp10(Number : extended):boolean;
begin;
if abs(number)>4932 then testp10:=false
                    else testp10:=true;
end;

function testnas(X, Y: EXTENDED):boolean;
begin;{to osklive cislo je log10 1.1e4932}
if (x<>0)and(y<>0) then
begin;
if (log10(abs(x))+log10(abs(y)))>4932.04139268516 then testnas:=false
                          else testnas:=true;
end else testnas:=true;
end;

function testp(X, Y: EXTENDED):boolean;
begin; {to osklive cislo je log10 1.1e4932}
if (x=0.0)and(y>0.0)  then testp:=true else
if (x=0.0)and(y<=0.0)  then testp:=false else
if log10(abs(x))>abs(4932.04139268516/y) then testp:=false
                                         else testp:=true;
end;

function testp2(Number : extended):boolean;
begin; {to osklive cislo je log2 1.1e4932}
if abs(number)>16383.886867508221 then testp2:=false
                                  else testp2:=true;
end;

function testexp(Number : extended):boolean;
begin; {to osklive cislo je ln 1.1e4932}
if abs(number)>11356.4449888264376 then testexp:=false
                                   else testexp:=true;
end;

function testsqr(Number : extended):boolean;
begin; {to osklive cislo je sqrt 1.1e4932}
if number>1.04880884817015e2466 then testsqr:=false
                                else testsqr:=true;
end;

function testfac(Number : extended):boolean;
begin;
if number>1754 then testfac:=false
               else testfac:=true;
end;

function testscit(X, Y: EXTENDED):boolean;
begin;
if sign(x)<> sign(y) then testscit:=true else
if abs(x)>abs(1.1e4932-abs(y)) then testscit:=false
                          else testscit:=true;
end;


FUNCTION Tan (X: EXTENDED): EXTENDED; ASSEMBLER;
ASM
   FLD   TBYTE PTR [X]    { get argument }
   INT   3Eh              { call shortcut interrupt }
   DW    90F0h            { signal Tan wanted to shortcut handler }
END;

FUNCTION Log10 (X: EXTENDED): EXTENDED; ASSEMBLER;
ASM
   FLD   TBYTE PTR [X]    { get argument }
   INT   3Eh              { call shortcut interrupt }
   DW    90F8h            { signal Log10 wanted to shortcut handler }
END;

FUNCTION Log2  (X: EXTENDED): EXTENDED; ASSEMBLER;
ASM
   FLD   TBYTE PTR [X]    { get argument }
   INT   3Eh              { call shortcut interrupt }
   DW    90F6h            { signal Log2 wanted to shortcut handler }
END;

FUNCTION Power10_ (X: EXTENDED): EXTENDED; ASSEMBLER;
ASM
   FLD   TBYTE PTR [X]    { get argument }
   INT   3Eh              { call shortcut interrupt }
   DW    90FEh            { signal Power of 10 wanted to shortcut handler}
END;

FUNCTION Power10 (X: EXTENDED): EXTENDED;
{pokud je mocnitel cele cisl budu nasobit}
var i:longint;
    vysl:extended;
BEGIN;
vysl:=1;
if frac(x)<>0.0 then
power10:=power10_(x)
else
begin;
if x>0 then
for i:=1 to round(x) do vysl:=vysl*10 else
if x<0 then
for i:=1 to round(-x) do vysl:=vysl/10;
power10:=vysl;
end;
END;

FUNCTION Power2 (X: EXTENDED): EXTENDED; ASSEMBLER;
ASM
   FLD   TBYTE PTR [X]    { get argument }
   INT   3Eh              { call shortcut interrupt }
   DW    90FCh            { signal Power of 2 wanted to shortcut handler }
END;

FUNCTION Power (X, Y: EXTENDED): EXTENDED; {X^Y}

VAR Z:        extended;
    IY:       LONGINT;

BEGIN { Power }
   IF Y = 0.0 THEN
      Power := 1.0
   ELSE IF (X = 2.0) THEN
      Power := Power2(Y)
   ELSE IF (X = 10.0) THEN
      Power := Power10(Y)
   ELSE IF (X = 0.0) AND (Y > 0.0) THEN
      Power := 0.0
   ELSE IF (Y = Int (Y)) AND (Abs(Y) <= MAXLONGINT) THEN BEGIN
      IY := TRUNC (Y);
      IF IY < 0 THEN
         X := 1/X;
      IY := Abs (IY);
      Z := 1.0;
      WHILE IY > 0 DO BEGIN
         IF Odd (IY) THEN
            Z := Z * X;
         IY := IY DIV 2;
         IF IY > 0 THEN
            X := Sqr (X);
      END; {endwhile}
      Power := Z;
      END { if Y = Int (....}
   ELSE
      Power := Exp (Y * Ln (X));
END; { Power }

function realround(x:extended):extended;
begin;
     if x>0 then if frac(x)<0.5 then realround := int(x)
                                else realround := int(x)+1
            else if frac(x)>-0.5 then realround :=int(x)
                                  else realround := int(x)-1;

end;

function realValid(x:extended;b:extended):extended;
var y:extended;
begin;
if x<>0.0 then
begin;
y:=power10(-int(log10(abs(x)))+b);
x:=x*y;
realValid:=int(x)/y;
end else realValid:=0.0;
end;

function realtrunc(x:extended):extended;
begin;
     realtrunc:=int(x);
end;

function realceil(x:extended):extended;
begin;
if x=int(x) then realceil:=x else
if x<0.0 then realceil:=int(x)-1
         else realceil:=int(x)+1;
end;

function Sign(Number : extended) : extended;
begin
     if (Number < 0.0) then Sign := -1.0
        else Sign := 1.0;
end;

FUNCTION realdiv (X, Y: EXTENDED): EXTENDED;
begin;
realdiv:=int(int(x)/int(y));
end;

FUNCTION realmod (X, Y: EXTENDED): EXTENDED;
begin;
realmod:=int(x)-(int(y)*realdiv(x,y));
end;

function Fact(Number : extended) : extended;
var vysl:extended;
begin;
vysl:=1.0;
while int(number)>=2 do
begin;
vysl:=vysl*int(number);
number:=int(number)-1;
end;
fact:=vysl;
end;

END. { UMath }
