{$N+,E+}
{****************************************************************************
 *           } Unit UMemory;{ (c) 1999 Michal Cihar                         *
 ****************************************************************************}
interface
uses udata,strfunc{,ucountry-};
const
      {error handling:}
      ErrOK              = 0;
      ErrVariableNotFound= 1;
      ErrBadName         = 2;
      ErrLowMemory       = 3;
      ErrIsConstant      = 4;
      ErrIsFunction      = 5;
      ErrTooLongName     = 6;
      ErrNoVariableFound = 7;
      ErrNameNotFound    = 8;
      ErrValueNotFound   = 9;
      ErrBadValue        =10;
      ErrFunctionNotFound=11;
      ErrNoFunctionFound =12;

      {file IO errors:}
      ErrFileNotFound    = 101;
      ErrReading         = 102;
      ErrWriting         = 103;
      ErrBlockID         = 104;
      ErrFileID          = 105;
      ErrPosition        = 106;
      ErrDataSize        = 107;


      {maximal variable name length
      WARNING: after change data files are incompatible}
      MaximalVariableNameLength     =40;
      FileCreatorString:string[8]='UMemory';

{memory handling:}
{}
{stores variable name s and Value into memory
if exists, velue is changed, if doesn't new one is created}
function IntoMemory(const s:string;const Value:tRealNumber):longint;
{gets variable with name s value}
function GetVariable(s:string;var b:boolean):tRealNumber;
{true if exists variable with name s }
function IsVariable(s:string):boolean;
{returns name of n-th variable}
function VariableName(const n:longint):string;
{deletes variable with name s}
function DeleteVariable(s:string):boolean;
{deletes all variables}
procedure DeleteAllVariables;
{returns variables count}
function VariableCount:longint;
{returns variable size}
function VariableSize:longint;
{returns true if was any memory change}
function MemoryChange:boolean;
{returns last memory change info}
function LastChange:string;

{soubory}
{loads all variables}
function LoadVariables(Name:string;WriteStatus:boolean):byte;
{saves all variables}
function SaveVariables(Name:string;WriteStatus:boolean):byte;
{loads all variables - old file format used}
function LoadVariables_Old(Name:string;WriteStatus:boolean):byte;
{saves all variables - old file format used}
function SaveVariables_Old(Name:string;WriteStatus:boolean):byte;
function LoadDBFVariables(Name:string;WriteStatus:boolean;var ErrCount:longint):byte;

{memory handling:}
{}
{stores variable name s and Value into memory
if exists, velue is changed, if doesn't new one is created}
function IntoParameters(const s:string;const Value:tRealNumber):longint;
{gets variable with name s value}
function GetParameter(s:string;var b:boolean):tRealNumber;
{true if exists variable with name s }
function IsParameter(s:string):boolean;
{returns name of n-th variable}
{function VariableName(const n:longint):string;
{deletes variable with name s}
function DeleteParameter(s:string):boolean;
{deletes all variables}
procedure DeleteAllParameters;

{constants}
{gets constant with name s value}
function GetConstant(s:string;var b:boolean):tRealNumber;
{gets constant with name s info}
function InfoConstant(s:string;var b:boolean):string;
{true if exists constant with name s }
function IsConstant(s:string):boolean;
{change ANS value - last result}
function ChangeANS(const Value:tRealNumber):boolean;
{returns name of n-th constant}
function ConstantName(const n:longint):string;
{returns constants count}
function ConstantCount:longint;
{returns constant size}
function ConstantSize:longint;

function FunctionSize:longint;

{chyby}
{returns error number - error flag is cleared}
function MemoryError:byte;
{returns error number - error flag is not cleared}
function MemoryError_:byte;

implementation
uses ufiles,dbase;
const ValidChars:set of char=['@'..'[','a'..'z','_','0'..'9',']',''..''];
var
  oldexit : pointer;

type
     pVariable=^tVariable;
     tVariable=record
                Name:string[MaximalVariableNameLength];
                Value:extended;
                Prev,Next:pVariable;
                end;
     lVariable=record
                First,Last:pVariable;
                Count:longint;
               end;

     pFunction=^tFunction;
     tFunction=record
                Name:string[MaximalVariableNameLength];
                FuncData:string;
                Prev,Next:pFunction;
                end;
     lFunction=record
                First,Last:pFunction;
                Count:longint;
               end;

     pConstant=^tConstant;
     tConstant=record
                Name:string[20];
                Info:string[50];
                Value:extended;
                Prev,Next:pConstant;
                end;
     lConstant=record
                First,Last:pConstant;
                Count:longint;
               end;

var
   MemErr:byte;
   Memory:lVariable;
   Parameters:lVariable;
   Constants:lConstant;
   Functions:lFunction;
   MemChange:boolean;
   MemLastChange:string;

function FormatVariableName(s:string):string;
var news:string;
    i:byte;
begin;
s:=StringUpCase(s);
news:='';
for i :=1 to length(s) do
begin;
    if s[i] in ValidChars then news:=news+s[i]
                          else break;
    if i>=MaximalVariableNameLength then break;
end;
FormatVariableName:=news;
end;

{velikost funkce}
function FunctionSize:longint;
begin;
FunctionSize:=sizeof(tFunction);
end;

{velikost promenne}
function VariableSize:longint;
begin;
VariableSize:=sizeof(tVariable);
end;

{velikost Constants}
function ConstantSize:longint;
begin;
ConstantSize:=sizeof(tConstant);
end;

{Count promennych}
function VariableCount:longint;
begin;
VariableCount:=Memory.Count;
end;

{Count konstant}
function ConstantCount:longint;
begin;
ConstantCount:=Constants.Count;
end;

{Last zmena v pameti}
function LastChange:string;
begin;
LastChange:=MemLastChange;
end;

{inicializace pameti}
procedure InitMemory;
begin;
with Memory do
begin;
 First:=nil;
 Last:=nil;
 Count:=0;
end;
MemErr:=ErrOK;
end;

{inicializace pameti}
procedure InitFunctions;
begin;
with Functions do
begin;
 First:=nil;
 Last:=nil;
 Count:=0;
end;
MemErr:=ErrOK;
end;

{inicializace parametru}
procedure InitParameters;
begin;
with Parameters do
begin;
 First:=nil;
 Last:=nil;
 Count:=0;
end;
MemErr:=ErrOK;
end;

{inicializace konstant}
procedure InitConstant;
begin;
with Constants do
begin;
 First:=nil;
 Last:=nil;
 Count:=0;
end;
MemErr:=ErrOK;
end;

{byla zmena v pameti - Next informace ziskat funkci poslednizmena}
function MemoryChange:boolean;
begin;
MemoryChange:=MemChange;
MemChange:=false;
end;

{byla chyba v pameti}
function MemoryError:byte;
begin;
MemoryError:=MemErr;
MemErr:=0;
end;

{totez jako Prev, ale nenuluje interni promennou}
function MemoryError_:byte;
begin;
MemoryError_:=MemErr;
end;

{zmeni hodnotu promenne - Name s a Value cislo}
function ChangeVariable(s:string;const cislo:tRealNumber):boolean;
var akt:pVariable;
begin;
akt:=Memory.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
begin;
   akt^.Value:=cislo;
   ChangeVariable:=true;
   MemChange:=true;
   MemLastChange:='Zmenena promenna '+s+' na hodnotu '+Number2String(cislo);
   MemErr:=ErrOK;
end else ChangeVariable:=false;
end;

{vrati hodnotu promenne se jmenem s}
function GetVariable(s:string;var b:boolean):tRealNumber;
var akt:pVariable;
begin;
akt:=Memory.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
   begin;
     GetVariable:=akt^.Value;
     b:=true;
     MemErr:=ErrOK;
   end
   else begin;b:=false;MemErr:=ErrVariableNotFound;end;
end;

{ulozi Memory do souboru Name}
function SaveVariables(Name:string;WriteStatus:boolean):byte;
var f:tFile;
    i:longint;
    temp:pVariable;
    datamem:record
                  Name:string[MaximalVariableNameLength];
                  value:extended;
                  end;
    h:tBlockHeader;
    b:tblock;
    temperr:byte;
begin;
f.FileName:=Name;
f.FileHeader:=DefaultFileHeader;
f.FileHeader.Creator:=FileCreatorString;
temperr:=FileNew(f);
if temperr<>ErrOK then begin;SaveVariables:=temperr;exit;end;
h:=EOFBlockHeader;
h.DataType:=TypeMemory;
h.RecordCount:=0;
h.Size:=0;
b.BlockHeader:=h;
b.RecordSize:=sizeof(tRealNumber)+1+MaximalVariableNameLength;
temperr:=NewBlock(f,b);
if temperr<>ErrOK then begin;SaveVariables:=temperr;exit;end;
temp:=Memory.First;
for i:=1 to Memory.Count do
begin;
  datamem.Name:=temp^.Name;
  datamem.value:=temp^.Value;
  temperr:=WriteBlockData(f,b,datamem);
  if temperr<>ErrOK then begin;SaveVariables:=temperr;exit;end;
  if WriteStatus then write(((i*100)/Memory.Count):5:2,' %'#13);
  temp:=temp^.Next;
  if temp=nil then break;
end;
temperr:=CloseBlock(f,b);
if temperr<>ErrOK then begin;SaveVariables:=temperr;exit;end;
temperr:=FileFinish(f);
if temperr<>ErrOK then begin;SaveVariables:=temperr;exit;end;
temperr:=FileClose(f);
if temperr<>ErrOK then begin;SaveVariables:=temperr;exit;end;
SaveVariables:=ErrOK;
end;

{ulozi Memory do souboru Name - format pouzivany do verze 1.1}
function SaveVariables_Old(Name:string;WriteStatus:boolean):byte;
var f:file;
    result:word;
    i:longint;
    temp:pVariable;
begin;
assign(f,Name);
{$i-}
rewrite(f,1);
if ioresult<> 0 then begin;SaveVariables_Old:=1;exit;end;
{$i+}
blockwrite(f,Memory,sizeof(lVariable),result);
if result<> sizeof(lVariable) then begin;SaveVariables_Old:=2;exit;end;
temp:=Memory.First;
for i:=1 to Memory.Count do
begin;
  blockwrite(f,temp^,sizeof(tVariable),result);
  if WriteStatus then write(((i*100)/Memory.Count):5:2,' %'#13);
  if result<> sizeof(tVariable) then begin;SaveVariables_Old:=3;exit;end;
  temp:=temp^.Next;
  if temp=nil then break;
end;
close(f);
SaveVariables_Old:=0;
end;

{nahraje Memory ze souboru Name}
function LoadVariables(Name:string;WriteStatus:boolean):byte;
var f:tFile;
    datamem:record
                  Name:string[MaximalVariableNameLength];
                  value:extended;
                  end;
    h:tBlockHeader;
    b:tblock;
    temperr:byte;
begin;
f.FileName:=Name;
temperr:=FileOpen(f);
if temperr<>ErrOK then begin;LoadVariables:=temperr;FileClose(f);exit;end;
repeat
temperr:=BlockReadHeader(f,b);
if temperr<>ErrOK then begin;LoadVariables:=temperr;FileClose(f);exit;end;
if b.BlockHeader.DataType=TypeMemory then
begin;
repeat
temperr:=BlockReadRecord(f,b,datamem);
if temperr<>ErrOK then begin;LoadVariables:=temperr;FileClose(f);exit;end;
IntoMemory(datamem.Name,datamem.value);
temperr:=MemErr;
if temperr<>ErrOK then begin;LoadVariables:=temperr;FileClose(f);exit;end;
  if WriteStatus then write(((filepos(f.PascalFile)*100)/f.FileHeader.Size):5:2,' %'#13);
until b.CurentlyReading=b.BlockHeader.RecordCount;
end else BlockIgnoreData(f,b);
  if WriteStatus then
  begin;
  if eof(f.PascalFile) then write('100 %'#13)
                       else write(((filepos(f.PascalFile)*100)/f.FileHeader.Size):5:2,' %'#13);
  end;
until b.BlockHeader.DataType=TypeEOF;
temperr:=FileClose(f);
if temperr<>ErrOK then begin;LoadVariables:=temperr;FileClose(f);exit;end;
LoadVariables:=ErrOK;
   MemChange:=true;
   MemLastChange:='Nahrany promenne ze souboru '+Name;
   MemErr:=ErrOK;
end;

function LoadDBFVariables(Name:string;WriteStatus:boolean;var ErrCount:longint):byte;
var p,J:longint;
    tempErr:byte;
    varname,varvalue:byte;
    newname:string;
    newvalue:tRealNumber;
    code:integer;
begin;
ErrCount:=0;
tempErr:=opendbfdata(name);
if temperr<>ErrOK then begin;LoadDBFVariables:=temperr;exit;end;
varname:=0;
varvalue:=0;
For J := 1 to DBFFieldCount do
    if DBFTypes[J]='C' then begin;varname:=j;break;end;
IF varname=0 then begin;LoadDBFVariables:=ErrNameNotFound;exit;end;
For J := varname to DBFFieldCount do
    if DBFTypes[J]='F' then begin;varvalue:=j;break;end;
if varValue=0 then
   For J := 1 to varname-1 do
       if DBFTypes[J]='F' then begin;varvalue:=j;break;end;
if varValue=0 then
   For J := varname to DBFFieldCount do
       if DBFTypes[J]='N' then begin;varvalue:=j;break;end;
if varValue=0 then
   For J := 1 to varname-1 do
       if DBFTypes[J]='N' then begin;varvalue:=j;break;end;
if varValue=0 then begin;LoadDBFVariables:=ErrValueNotFound;exit;end;
for p:=1 to DBFHeading.RecordCount do
begin;
  readdbfrecord(p);
  newname:=FormatVariableName(copy(DBFFieldContent[varname],1,40));
  if WriteStatus then write(((p*100)/DBFHeading.RecordCount):5:2,' %'#13);
  if DBFFieldContent[varvalue]=ReturnNChars(' ',DBFLengths[varvalue])
     then begin;code:=0;newvalue:=0;end
     else val(DBFFieldContent[varvalue],newvalue,code);
  if code<>0 then begin;LoadDBFVariables:=ErrBadValue;exit;end;
  IntoMemory(newname,newvalue);
  temperr:=MemErr;
  if temperr<>ErrOK then inc(ErrCount);
                        {begin;LoadDBFVariables:=temperr;exit;end;}
end;
write('100 %'#13);
LoadDBFVariables:=ErrOK;
   MemChange:=true;
   MemLastChange:='Nahrany promenne ze souboru '+Name;
   MemErr:=ErrOK;
end;

{nahraje Memory ze souboru Name - format pouzivany do verze 1.1}
function LoadVariables_Old(Name:string;WriteStatus:boolean):byte;
var f:file;
    result:word;
    i:longint;
    temp:pVariable;
    templ:lVariable;
begin;
assign(f,Name);
{$i-}
reset(f,1);
if ioresult<> 0 then begin;
                                     MemChange:=false;
LoadVariables_Old:=1;exit;end;
{$i+}
blockread(f,templ,sizeof(lVariable),result);
if result<> sizeof(lVariable) then begin;
                                     MemChange:=false;
LoadVariables_Old:=2;exit;end;
if templ.Count<1 then begin;
                                     MemChange:=false;
LoadVariables_Old:=4;exit;end;
new(temp);
for i:=1 to templ.Count do
begin;
  blockread(f,temp^,sizeof(tVariable),result);
  if WriteStatus then write(((i*100)/templ.Count):5:2,' %'#13);
  if result<> sizeof(tVariable) then begin;
                                     MemChange:=false;
                                     LoadVariables_Old:=3;exit;end;
  IntoMemory(temp^.Name,temp^.Value);
  if MemErr<>0 then begin;
                        LoadVariables_Old:=5;
                        MemChange:=false;
                        exit;end;
end;
close(f);
LoadVariables_Old:=0;
   MemChange:=true;
   MemLastChange:='Nahrany promenne ze souboru '+Name;
   MemErr:=ErrOK;
end;

{vrati Name n-te promenne - pro vypis promennych}
function VariableName(const n:longint):string;
var akt:pVariable;
    x:longint;
begin;
if n<=Memory.Count then
begin;
akt:=Memory.First;
x:=1;
while x<n do begin;akt:=akt^.Next;inc(x);end;
VariableName:=akt^.Name;
end else VariableName:='';
end;

{vrati Name n-te Constants - pro vypis konstant}
function ConstantName(const n:longint):string;
var akt:pConstant;
    x:longint;
begin;
if n<=Constants.Count then
begin;
akt:=Constants.First;
x:=1;
while x<n do begin;akt:=akt^.Next;inc(x);end;
ConstantName:=akt^.Name;
end else ConstantName:='';
end;

{vrati hodnotu Constants se jmenem s}
function GetConstant(s:string;var b:boolean):tRealNumber;
var akt:pConstant;
begin;
akt:=Constants.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
   begin;
     GetConstant:=akt^.Value;
     b:=true;
     MemErr:=ErrOK;
   end
   else begin;b:=false;MemErr:=ErrVariableNotFound;end;
end;

{vrati informace o konstante se jmenem s}
function InfoConstant(s:string;var b:boolean):string;
var akt:pConstant;
begin;
akt:=Constants.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
   begin;
     InfoConstant:=akt^.Info;
     b:=true;
     MemErr:=ErrOK;
   end
   else begin;b:=false;MemErr:=ErrVariableNotFound;end;
end;

{zjisti jestli je promenna se jmenem s v pameti}
function IsVariable(s:string):boolean;
var akt:pVariable;
begin;
if Memory.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Memory.First;
while akt^.Next<>nil do
      if S=akt^.Name then break
                               else akt:=akt^.Next;
if S=akt^.Name then IsVariable:=true else IsVariable:=false;
end else IsVariable:=false;
end;

{zjisti jestli existuje konsanta se jmenem s v pameti}
function IsConstant(s:string):boolean;
var akt:pConstant;
begin;
if Constants.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Constants.First;
while akt^.Next<>nil do
      if S=akt^.Name then break
                               else akt:=akt^.Next;
if S=akt^.Name then IsConstant:=true else IsConstant:=false;
end else IsConstant:=false;
end;

{zrusi promennou se jmenem s}
function DeleteVariable(s:string):boolean;
var akt:pVariable;
begin;
if Memory.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Memory.First;
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
begin;
  if akt^.Prev<>nil then (akt^.Prev)^.Next:=akt^.Next
                         else Memory.First:=akt^.Next;
  if akt^.Next<>nil then (akt^.Next)^.Prev:=akt^.Prev
                     else Memory.Last:=akt^.Prev;
  dispose(akt);
  DeleteVariable:=true;
  MemChange:=true;
  Memory.Count:=Memory.Count-1;
  MemLastChange:='Zrusena promenna '+s;
  MemErr:=ErrOK;
end else begin;DeleteVariable:=false;MemErr:=ErrVariableNotFound;end;
end else begin;DeleteVariable:=false;MemErr:=ErrNoVariableFound;end;
end;

{zrusi konstantu se jmenem s}
function Zrus_Konst(s:string):boolean;
var akt:pConstant;
begin;
akt:=Constants.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
begin;
  if akt^.Prev<>nil then (akt^.Prev)^.Next:=akt^.Next
                         else Constants.First:=akt^.Next;
  if akt^.Next<>nil then (akt^.Next)^.Prev:=akt^.Prev
                     else Constants.Last:=akt^.Prev;
  dispose(akt);
  Zrus_konst:=true;
  MemChange:=true;
  Constants.Count:=Constants.Count-1;
  MemLastChange:='Zrusena konstanta '+s;
  MemErr:=ErrOK;
end else begin;Zrus_konst:=false;MemErr:=ErrVariableNotFound;end;
end;

{zavede novou promennou se jmenem s}
function NewVariable(const s:string;const Value:tRealNumber):longint;
var prom:pVariable;
begin;
if length(s)<=MaximalVariableNameLength then
begin;
 if upcase(s[1]) in ['A'..'Z','_'] then
  begin;
  if MaxAvail>=VariableSize then
   begin;
    new(prom);
    if prom=nil then
     begin;
      NewVariable:=Memory.Count;
      MemErr:=ErrLowMemory;
     end else
     begin;
      prom^.Name:=StringUpCase(s);
      prom^.Value:=Value;
      if Memory.First=nil then
                          begin;
                            Memory.First:=prom;
                            Memory.Last:=prom;
                            prom^.Next:=nil;
                            prom^.Prev:=nil;
                          end
                         else
                          begin;
                            prom^.Prev:=Memory.Last;
                            (Memory.Last)^.Next:=prom;
                            Memory.Last:=prom;
                            prom^.Next:=nil;
                          end;
      Memory.Count:=Memory.Count+1;
      NewVariable:=Memory.Count;
      MemLastChange:='Nova promenna '+s+'='+Number2String(Value);
      MemChange:=true;
      MemErr:=ErrOK;
     end;
   end else
   begin;
     NewVariable:=Memory.Count;
     MemErr:=ErrLowMemory;
   end;
  end else
  begin;
   MemErr:=ErrBadName;
   NewVariable:=Memory.Count;
  end;
 end else
 begin;
   MemErr:=ErrTooLongName;
   NewVariable:=Memory.Count;
 end;
end;

{ulozi do pameti promennou se jmenem s - pokud neexistuje zalozi novou,
                                         jinak zmeni hodnotu}
function IntoMemory(const s:string;const Value:tRealNumber):longint;
var prom:pVariable;
begin;
if IsVariable(s) then
begin;
  ChangeVariable(s,Value);
  IntoMemory:=Memory.Count;
end else
if not(IsConstant(s)) then
if not(IsFunction(s)){pos(StringUpCase(s),znamefunkce)=0} then
IntoMemory:=NewVariable(s,Value)
else MemErr:=ErrIsFunction
else MemErr:=ErrIsConstant;
end;

{zavede novou konstantu se jmenem s}
function NewConstant(const s,Info:string;const Value:tRealNumber):longint;
var prom:pConstant;
begin;
if upcase(s[1]) in ['A'..'Z','_'] then
begin;
new(prom);
if prom=nil then
begin;
NewConstant:=Constants.Count;
MemErr:=ErrLowMemory;
end else
begin;
prom^.Name:=StringUpCase(s);
prom^.Info:=Info;
prom^.Value:=Value;
if Constants.First=nil then
                    begin;
                      Constants.First:=prom;
                      Constants.Last:=prom;
                      prom^.Next:=nil;
                      prom^.Prev:=nil;
                    end
                   else
                    begin;
                      (Constants.Last)^.Next:=prom;
                      Constants.Last:=prom;
                      prom^.Next:=nil;
                      prom^.Prev:=nil;
                    end;
Constants.Count:=Constants.Count+1;
NewConstant:=Constants.Count;
MemLastChange:='Nova promenna '+s+'='+Number2String(Value);
MemChange:=true;
MemErr:=ErrOK;
end;
end else
begin;
MemErr:=ErrBadName;
NewConstant:=Constants.Count;
end;
end;

{zmeni hodnotu konstnty ANS - Value posledniho vypoctu}
function ChangeANS(const Value:tRealNumber):boolean;
var akt:pConstant;
begin;
akt:=Constants.First;
while 'ANS'<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if 'ANS'=akt^.Name then
begin;
   akt^.Value:=Value;
   ChangeANS:=true;
end else ChangeANS:=false;
end;

{zrusi Memory}
procedure DeleteAllVariables;
begin;
while Memory.Count>0 do
begin;
if Memory.First<> nil then
DeleteVariable(Memory.First^.Name);
end;
end;

{zrusi Constants}
procedure zruskonst;
begin;
while Constants.Count>0 do
begin;
zrus_konst(Constants.First^.Name);
end;
end;

{zmeni hodnotu promenne - Name s a Value cislo}
function ChangeParameter(s:string;const cislo:tRealNumber):boolean;
var akt:pVariable;
begin;
akt:=Parameters.First;
s:=StringUpCase(s);
while s<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if s=akt^.Name then
begin;
   akt^.Value:=cislo;
   ChangeParameter:=true;
   MemErr:=ErrOK;
end else ChangeParameter:=false;
end;

{vrati hodnotu promenne se jmenem s}
function GetParameter(s:string;var b:boolean):tRealNumber;
var akt:pVariable;
begin;
akt:=Parameters.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
   begin;
     GetParameter:=akt^.Value;
     b:=true;
     MemErr:=ErrOK;
   end
   else begin;b:=false;MemErr:=ErrVariableNotFound;end;
end;

{zavede novou promennou se jmenem s}
function NewParameter(s:string;const Value:tRealNumber):longint;
var prom:pVariable;
begin;
if length(s)<=MaximalVariableNameLength then
begin;
  s:=StringUpCase(s);
 if s[1] in ['A'..'Z','_'] then
  begin;
  if MaxAvail>=VariableSize then
   begin;
    new(prom);
    if prom=nil then
     begin;
      NewParameter:=Parameters.Count;
      MemErr:=ErrLowMemory;
     end else
     begin;
      prom^.Name:=S;
      prom^.Value:=Value;
      if Parameters.First=nil then
                          begin;
                            Parameters.First:=prom;
                            Parameters.Last:=prom;
                            prom^.Next:=nil;
                            prom^.Prev:=nil;
                          end
                         else
                          begin;
                            prom^.Prev:=Parameters.Last;
                            (Parameters.Last)^.Next:=prom;
                            Parameters.Last:=prom;
                            prom^.Next:=nil;
                          end;
      Parameters.Count:=Parameters.Count+1;
      NewParameter:=Parameters.Count;
      MemErr:=ErrOK;
     end;
   end else
   begin;
     NewParameter:=Parameters.Count;
     MemErr:=ErrLowMemory;
   end;
  end else
  begin;
   MemErr:=ErrBadName;
   NewParameter:=Parameters.Count;
  end;
 end else
 begin;
   MemErr:=ErrTooLongName;
   NewParameter:=Parameters.Count;
 end;
end;


{ulozi do pameti promennou se jmenem s - pokud neexistuje zalozi novou,
                                         jinak zmeni hodnotu}
function IntoParameters(const s:string;const Value:tRealNumber):longint;
var prom:pVariable;
begin;
if IsParameter(s) then
begin;
  ChangeParameter(s,Value);
  IntoParameters:=Parameters.Count;
end else
{if not(IsConstant(s)) then
if not(IsFunction(s)) then}
IntoParameters:=NewParameter(s,Value)
{else MemErr:=ErrIsFunction
else MemErr:=ErrIsConstant;}
end;

{zjisti jestli je promenna se jmenem s v pameti}
function IsParameter(s:string):boolean;
var akt:pVariable;
begin;
if Parameters.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Parameters.First;
while akt^.Next<>nil do
      if S=akt^.Name then break
                               else akt:=akt^.Next;
if S=akt^.Name then IsParameter:=true else IsParameter:=false;
end else IsParameter:=false;
end;

{zrusi promennou se jmenem s}
function DeleteParameter(s:string):boolean;
var akt:pVariable;
begin;
if Parameters.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Parameters.First;
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
begin;
  if akt^.Prev<>nil then (akt^.Prev)^.Next:=akt^.Next
                         else Parameters.First:=akt^.Next;
  if akt^.Next<>nil then (akt^.Next)^.Prev:=akt^.Prev
                     else Parameters.Last:=akt^.Prev;
  dispose(akt);
  DeleteParameter:=true;
  Parameters.Count:=Parameters.Count-1;
  MemErr:=ErrOK;
end else begin;DeleteParameter:=false;MemErr:=ErrVariableNotFound;end;
end else begin;DeleteParameter:=false;MemErr:=ErrNoVariableFound;end;
end;

{zrusi Memory}
procedure DeleteAllParameters;
begin;
while Parameters.Count>0 do
begin;
if Parameters.First<> nil then
DeleteParameter(Parameters.First^.Name);
end;
end;
(*
{zmeni hodnotu promenne - Name s a Value cislo}
function ChangeFunction(name,data:string):boolean;
var akt:pFunction;
begin;
akt:=Functions.First;
name:=StringUpCase(name);
while name<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if name=akt^.Name then
begin;
   akt^.FuncData:=data;
   ChangeFunction:=true;
   MemChange:=true;
   MemLastChange:='Zmenena funkce '+name+' na '+data;
   MemErr:=ErrOK;
end else ChangeFunction:=false;
end;

{vrati hodnotu promenne se jmenem s}
function GetFunction(s:string;var b:boolean):string;
var akt:pFunction;
begin;
akt:=Functions.First;
s:=StringUpCase(s);
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
   begin;
     GetFunction:=akt^.FuncData;
     b:=true;
     MemErr:=ErrOK;
   end
   else begin;b:=false;MemErr:=ErrFunctionNotFound;end;
end;

{vrati Name n-te promenne - pro vypis promennych}
function FunctionName(const n:longint):string;
var akt:pFunction;
    x:longint;
begin;
if n<=Functions.Count then
begin;
akt:=Functions.First;
x:=1;
while x<n do begin;akt:=akt^.Next;inc(x);end;
FunctionName:=akt^.Name;
end else FunctionName:='';
end;

{zjisti jestli je promenna se jmenem s v pameti}
function IsFunction(s:string):boolean;
var akt:pFunction;
begin;
if Functions.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Functions.First;
while akt^.Next<>nil do
      if S=akt^.Name then break
                               else akt:=akt^.Next;
if S=akt^.Name then IsFunction:=true else IsFunction:=false;
end else IsFunction:=false;
end;

{zrusi promennou se jmenem s}
function DeleteFunction(s:string):boolean;
var akt:pFunction;
begin;
if Functions.First<>nil then
begin;
s:=StringUpCase(s);
akt:=Functions.First;
while S<>akt^.Name do if akt^.Next<>nil then akt:=akt^.Next else break;
if S=akt^.Name then
begin;
  if akt^.Prev<>nil then (akt^.Prev)^.Next:=akt^.Next
                         else Functions.First:=akt^.Next;
  if akt^.Next<>nil then (akt^.Next)^.Prev:=akt^.Prev
                     else Functions.Last:=akt^.Prev;
  dispose(akt);
  DeleteFunction:=true;
  MemChange:=true;
  Functions.Count:=Functions.Count-1;
  MemLastChange:='Zrusena promenna '+s;
  MemErr:=ErrOK;
end else begin;DeleteFunction:=false;MemErr:=ErrFunctionNotFound;end;
end else begin;DeleteFunction:=false;MemErr:=ErrNoFunctionFound;end;
end;

{zavede novou promennou se jmenem s}
function NewFunction(const s,data:string):longint;
var prom:pFunction;
begin;
if length(s)<=MaximalVariableNameLength then
begin;
 if upcase(s[1]) in ['A'..'Z','_'] then
  begin;
  if MaxAvail>=FunctionSize then
   begin;
    new(prom);
    if prom=nil then
     begin;
      NewFunction:=Functions.Count;
      MemErr:=ErrLowMemory;
     end else
     begin;
      prom^.Name:=StringUpCase(s);
      prom^.FuncData:=data;
      if Functions.First=nil then
                          begin;
                            Functions.First:=prom;
                            Functions.Last:=prom;
                            prom^.Next:=nil;
                            prom^.Prev:=nil;
                          end
                         else
                          begin;
                            prom^.Prev:=Functions.Last;
                            (Functions.Last)^.Next:=prom;
                            Functions.Last:=prom;
                            prom^.Next:=nil;
                          end;
      Functions.Count:=Functions.Count+1;
      NewFunction:=Functions.Count;
      MemLastChange:='Nova funkce '+s+'='+data;
      MemChange:=true;
      MemErr:=ErrOK;
     end;
   end else
   begin;
     NewFunction:=Functions.Count;
     MemErr:=ErrLowMemory;
   end;
  end else
  begin;
   MemErr:=ErrBadName;
   NewFunction:=Functions.Count;
  end;
 end else
 begin;
   MemErr:=ErrTooLongName;
   NewFunction:=Functions.Count;
 end;
end;

{ulozi do pameti promennou se jmenem s - pokud neexistuje zalozi novou,
                                         jinak zmeni hodnotu}
function IntoFunctions(const s,data:string):longint;
var prom:pFunction;
begin;
if IsFunction(s) then
begin;
  ChangeFunction(s,data);
  IntoFunctions:=Functions.Count;
end else
if not(IsConstant(s)) then
if not(IsFunction(s)){pos(StringUpCase(s),znamefunkce)=0} then
IntoFunctions:=NewFunction(s,data)
else MemErr:=ErrIsFunction
else MemErr:=ErrIsConstant;
end;

{zrusi Functions}
procedure DeleteAllFunctions;
begin;
while Functions.Count>0 do
begin;
if Functions.First<> nil then
DeleteFunction(Functions.First^.Name);
end;
end;*)


{procedura uvolnujici Memory pri ukonceni programu}
procedure exit_upamet;far;
begin
  exitproc := oldexit;
  DeleteAllVariables;
  DeleteAllParameters;
(*  DeleteAllFunctions;*)
  zruskonst;
end;

begin;
{nastavime uvolneni pameti pri ukonceni programu:}
  oldexit  := exitproc;
  exitproc := @exit_upamet;
InitMemory;
InitParameters;
InitConstant;
(*InitFunctions;*)
{1}
NewConstant('ans','Vysledek posledniho vypoctu',0.0);
NewConstant('e','Eulerovo cislo',{2.71828182845904524}exp(1));
NewConstant('pi','Ludolfovo cislo',{3.14159265358979324}pi);
NewConstant('_mp','Klidova hmotnost protonu [kg]',1.6726231e-27);
{5}
NewConstant('_f','Faradayova konstanta [C/mol]',96485.309);
NewConstant('_A0','Bohruv polomer [m]',5.29177249e-11);
NewConstant('_c','Rychlost svetla ve vakuu [m/s]',299792458);
NewConstant('_h','Plankova konstanta [J*s]',66.6260755e-34);
NewConstant('_gk','Gravitacni konstanta [N*m*m/kg*kg]',6.67259e-11);
{10}
NewConstant('_e','Elementarni naboj [C]',1.60217733e-19);
NewConstant('_me','Klidova hmotnost elektronu [kg]',9.1093897e-31);
NewConstant('_u','Hmotnostni atomova jednotka [kg]',1.6605402e-27);
NewConstant('_Na','Avogadrova konstanta [1/mol]',6.0221367e+23);
NewConstant('_k','Boltzmannova konstanta [J/K]',1.380658e-23);
{15}
NewConstant('_g','Gravitacni zrychleni [m/s*s]',9.80665);
NewConstant('_r','Molarni plynova konstnta [J/mol*k]',8.314510);
NewConstant('_e0','Permitivita vakua [F/m]',8.8541878176204e-12);
NewConstant('_u0','Permeabilita vakua [H/m]',1.2566370614359e-6);
NewConstant('_uB','Bohruv magneton [A/m*m]',9.2740154e-24);
{20}
NewConstant('_hk','Konvertovana Plankova konstanta (h/2pi)[J*s]',1.05457266e-34);
NewConstant('_mn','Klidova hmotnost neutronu [kg]',1.6749286e-27);
NewConstant('_R8','Rydbergova konstanta [1/m]',10973731.53);
NewConstant('_o','Stefan-Boltzmannova konstanta [W/m*m*k*k*k*k]',5.67051e-08);
NewConstant('Zetta','Prepona [Z]',1e21);
{25}
NewConstant('Exa','Prepona [E]',1e18);
NewConstant('peta','Prepona [P]',1e15);
NewConstant('tera','Prepona [T]',1e12);
NewConstant('giga','Prepona [G]',1e9);
NewConstant('Mega','Prepona [M]',1e6);
{30}
NewConstant('kilo','Prepona [k]',1e3);
NewConstant('hecta','Prepona [h]',1e2);
NewConstant('deca','Prepona [da]',1e1);
NewConstant('deci','Prepona [d]',1e-1);
NewConstant('centi','Prepona [c]',1e-2);
{35}
NewConstant('mili','Prepona [m]',1e-3);
NewConstant('micro','Prepona [u]',1e-6);
NewConstant('nano','Prepona [n]',1e-9);
NewConstant('piko','Prepona [p]',1e-12);
NewConstant('femto','Prepona [f]',1e-15);
{40}
NewConstant('atto','Prepona [a]',1e-18);
NewConstant('zepto','Prepona [z]',1e-21);
NewConstant('yokto','Prepona [y]',1e-24);

MemErr:=0;
MemChange:=false;
MemLastChange:='';
end.